/*******************************************************************************
***        module: types.h
***            by: Jack Eberson
***      compiler: MikroC PRO for ARM V6.0.0
***      hardware: Mikromedia plus with STM32F476ZG and shield
***   description: types / variable declarations
*******************************************************************************/

// Define 50ms timers
#ifndef __TYPES_H
#define __TYPES_H

enum _T_50ms
{
  _T50ms_generic,
  _T50ms_timers
};

// Define 100ms timers
enum _T_100ms
{
  _T100ms_generic,
  _T100ms_LED_R,
  _T100ms_LED_G,
  _T100ms_LED_B,
  _T100ms_CAN,
  _T100ms_CAN_TxIndicator,
  _T100ms_CAN_RxIndicator,
  _T100ms_timers
};

// Define 1s timers
enum _T_1s
{
  _T1s_generic,
  _T1s_ClockSync,
  _T1s_CleanShot,
  _T1s_timers
};

typedef unsigned char      uint8_t;
typedef unsigned int       uint16_t;
typedef unsigned long      uint32_t;
typedef unsigned long long uint64_t;

typedef signed char        sint8_t;
typedef signed int         sint16_t;
typedef signed long        sint32_t;
typedef signed long long   sint64_t;

// Define blinking speed structure
typedef struct
{
   sint8_t speed;
   sint8_t limit_min;
   sint8_t limit_max;
   sint8_t defaultvalue;
} sBlinkingSpeed;

typedef enum {_taFirst, _taSecond} TOperand;

#define SCRN_HOME            0
#define SCRN_HELP            1
#define SCRN_INPUT_VALUE     2

#define FIELD_BLINKINGSPEED_RED    0
#define FIELD_BLINKINGSPEED_GREEN  1
#define FIELD_BLINKINGSPEED_BLUE   2

#endif

extern uint32_t T50ms[_T50ms_timers];     // 100ms timers
extern uint32_t T100ms[_T100ms_timers];   // 100ms timers
extern uint32_t T1s[_T1s_timers];         // 1s timers

extern uint8_t blinkLED_R;
extern uint8_t blinkLED_G;
extern uint8_t blinkLED_B;

extern uint8_t updateBoxblinkspeedRed;
extern uint8_t updateBoxblinkspeedGreen;
extern uint8_t updateBoxblinkspeedBlue;

extern uint8_t ledupdateCANTX, ledstatusCANTX;
extern uint8_t ledupdateCANRX, ledstatusCANRX;

extern sfr sbit LED_R;
extern sfr sbit LED_G;
extern sfr sbit LED_B;

extern uint8_t screenState;
extern uint8_t ValueInputBuffer[];

extern sBlinkingSpeed BlinkingSpeedRed;
extern sBlinkingSpeed BlinkingSpeedGreen;
extern sBlinkingSpeed BlinkingSpeedBlue;