/*******************************************************************************
***        module: can.h
***            by: Jack Eberson
***      compiler: MikroC PRO for ARM V6.0.0
***      hardware: STM32F746ZG
***   description: Mikromedia plus STM32F746ZG CAN bus module routines
***
***   Select the appropriate CAN speed by selecting the appropriate macro.
*******************************************************************************/

#ifndef __CAN_H
#define __CAN_H

#define CAN_RETRANSMIT_TIME    10  // <-- every 10*100ms

#endif

extern uint32_t Can_Init_Flags;
extern uint8_t  Can_Send_Flags;
extern uint8_t  Can_Rcv_Flags;

extern uint32_t Rx_ID;  
extern uint8_t  Rx_DLC;
extern uint8_t  RxTx_Data[];

void Init_CAN();
void WriteCAN_Message();