/*******************************************************************************
***        module: declarations.c
***            by: Jack Eberson
***      compiler: MikroC PRO for ARM V6.0.0
***      hardware: Mikromedia plus with STM32F746ZG and shield
***   description: global variable declarations
*******************************************************************************/
#include "types.h"

// Define software timers
uint32_t T50ms[_T50ms_timers];     // 100ms timers
uint32_t T100ms[_T100ms_timers];   // 100ms timers
uint32_t T1s[_T1s_timers];         // 1s timers

// Led status/update variables
uint8_t blinkLED_R,blinkLED_G,blinkLED_B;
uint8_t ledupdateCANTX, ledstatusCANTX;
uint8_t ledupdateCANRX, ledstatusCANRX;
uint8_t updateBoxblinkspeedRed, updateBoxblinkspeedGreen, updateBoxblinkspeedBlue;

uint8_t ValueInputBuffer[50];

/// Screen state
uint8_t screenState;

// LED pins for the RGB led on module
sbit LED_R at GPIOG_ODR.B15;
sbit LED_G at GPIOB_ODR.B3;
sbit LED_B at GPIOB_ODR.B4;

// Led blink speed vaiables
sBlinkingSpeed BlinkingSpeedRed;
sBlinkingSpeed BlinkingSpeedGreen;
sBlinkingSpeed BlinkingSpeedBlue;