#include "mmp_leddemo_objects.h"
#include "types.h"
#include "circularbuffer.h"
#include "CAN.h"
#include "mmp_leddemo_helpers.h"


void _HelpScreenActions()
{
    // CAN data available in the buffer?
    if (ringBufS_pop(&ringBufferCAN, &CANmsg) != -1)
    {
       // Handling the appropriate CAN message
       if (CANmsg.cmsgID == 0xAFF1)  // <-- blink speed of the RED led
       {
          // Update the received CAN data in the display when the HOME screen is displayed
          UpdateCanData = 1;
          
          if ((CANmsg.cmsgData[0] >= BlinkingSpeedRed.limit_min) && (CANmsg.cmsgData[0] <= BlinkingSpeedRed.limit_max))
          {
             BlinkingSpeedRed.speed = (uint32_t)CANmsg.cmsgData[0];
             updateBoxblinkspeedRed = 1;
             T100ms[_T100ms_CAN] = 0; // reset CAN write timer to force a CAN message being transmitted
          }
       }
       else if (CANmsg.cmsgID == 0xAFF2) // <-- blink speed of the GREEN led
       {
          // Update the received CAN data in the display when the HOME screen is displayed
          UpdateCanData = 1;

          if ((CANmsg.cmsgData[0] >= BlinkingSpeedGreen.limit_min) && (CANmsg.cmsgData[0] <= BlinkingSpeedGreen.limit_max))
          {
             BlinkingSpeedGreen.speed = (uint32_t)CANmsg.cmsgData[0];
             updateBoxblinkspeedGreen = 1;
             T100ms[_T100ms_CAN] = 0; // reset CAN write timer to force a CAN message being transmitted
          }
       }
       else if (CANmsg.cmsgID == 0xAFF3) // <-- blink speed of the BLUE led
       {
          // Update the received CAN data in the display when the HOME screen is displayed
          UpdateCanData = 1;

          if ((CANmsg.cmsgData[0] >= BlinkingSpeedBlue.limit_min) && (CANmsg.cmsgData[0] <= BlinkingSpeedBlue.limit_max))
          {
             BlinkingSpeedBlue.speed = (uint32_t)CANmsg.cmsgData[0];
             updateBoxblinkspeedBlue = 1;
             T100ms[_T100ms_CAN] = 0; // reset CAN write timer to force a CAN message being transmitted
          }
       }
       else if (CANmsg.cmsgID == 0xAFF0) // <-- blink speed defaults for all leds
       {
          // Update the received CAN data in the display when the HOME screen is displayed
          UpdateCanData = 1;

          BlinkingSpeedRed.speed   = (uint32_t)BlinkingSpeedRed.defaultvalue;
          BlinkingSpeedGreen.speed = (uint32_t)BlinkingSpeedGreen.defaultvalue;
          BlinkingSpeedBlue.speed  = (uint32_t)BlinkingSpeedBlue.defaultvalue;
          T100ms[_T100ms_CAN] = 0; // reset CAN write timer to force a CAN message being transmitted
       }
       else
       {
          // Update the received CAN data in the display when the HOME screen is displayed
          UpdateCanData = 1;
       }
    }
    
    // Handle blinking of RED led
    if (blinkLED_R)
    {
       if (T100ms[_T100ms_LED_R] == 0)
       {
          LED_R ^= 1;
          T100ms[_T100ms_LED_R] = BlinkingSpeedRed.speed;
       }
    }

    // Handle blinking of GREEN led
    if (blinkLED_G)
    {
       if (T100ms[_T100ms_LED_G] == 0)
       {
          LED_G ^= 1;
          T100ms[_T100ms_LED_G] = BlinkingSpeedGreen.speed;
       }
    }

    // Handle blinking of BLUE led
    if (blinkLED_B)
    {
       if (T100ms[_T100ms_LED_B] == 0)
       {
          LED_B ^= 1;
          T100ms[_T100ms_LED_B] = BlinkingSpeedBlue.speed;
       }
    }
}