#include "mmp_leddemo_objects.h"
#include "mmp_leddemo_resources.h"
#include "built_in.h"
#include "types.h"

void InitTimer2();
void resetTimers();

// TFT module connections
sbit TFT_BLED at GPIOF_ODR.B10;
sbit TFT_CS at GPIOF_ODR.B13;
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RD at GPIOF_ODR.B12;
sbit TFT_RS at GPIOF_ODR.B15;
sbit TFT_RST at GPIOF_ODR.B14;
sbit TFT_WR at GPIOF_ODR.B11;
// End TFT module connections



// Global variables
unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
//TPointer PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TImage *local_image;
TImage *exec_image;
int image_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;
TBox *local_box;
TBox *exec_box;
int box_order;
TBox_Round *local_round_box;
TBox_Round *exec_round_box;
int box_round_order;


void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
  unsigned int temp;
  temp = GPIOE_ODR;
  temp &= 0x00FF;
  GPIOE_ODR = temp | (_hi << 8);
  temp = GPIOG_ODR;
  temp &= 0xFF00;
  GPIOG_ODR = temp | _lo;
}

void Set_Index(unsigned short index) {
  TFT_RS = 0;
  Write_to_Data_Lines(0, index);
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Command(unsigned short cmd) {
  TFT_RS = 1;
  Write_to_Data_Lines(0, cmd);
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Data(unsigned int _data) {
  TFT_RS = 1;
  Write_to_Data_Lines(Hi(_data), Lo(_data));
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

static void InitializeTouchPanel() {
  TFT_Set_Active(Set_Index, Write_Command, Write_Data);
  TFT_Init_SSD1963(480, 272);

  TFT_Set_DBC_SSD1963(255);

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                home;
  TBox                   Box1;
  TLabel                 MainLabel;
char MainLabel_Caption[19] = "RGB-LED / CAN demo";

  TButton               bRedOn;
char bRedOn_Caption[7] = "RED on";

  TButton               bRedOff;
char bRedOff_Caption[8] = "RED off";

  TButton               bGreenOn;
char bGreenOn_Caption[9] = "GREEN on";

  TButton               bGreenOff;
char bGreenOff_Caption[10] = "GREEN off";

  TButton               bBlueOn;
char bBlueOn_Caption[8] = "BLUE on";

  TButton               bBlueOff;
char bBlueOff_Caption[9] = "BLUE off";

  TButton               bRedBlink;
char bRedBlink_Caption[10] = "RED blink";

  TButton               bGreenBlink;
char bGreenBlink_Caption[12] = "GREEN blink";

  TButton               bBlueBlink;
char bBlueBlink_Caption[11] = "BLUE blink";

  TLine                  TopLine;
  TCircle                LedRedIndicator;
  TCircle                LedGreenIndicator;
  TCircle                LedBlueIndicator;
  TLabel                 l_ID;
char l_ID_Caption[4] = "ID:";

  TLabel                 l_DLC;
char l_DLC_Caption[5] = "DLC:";

  TLabel                 l_DATA;
char l_DATA_Caption[6] = "DATA:";

  TCircle                CANRXIndicator;
  TLabel                 l_CANRX;
char l_CANRX_Caption[7] = "CAN Rx";

  TBox                   dynamicbox_1;
  TLabel                 rcvdID;
char rcvdID_Caption[3] = "--";

  TLabel                 rcvdDLC;
char rcvdDLC_Caption[3] = "--";

  TLabel                 rcvdDB0;
char rcvdDB0_Caption[3] = "--";

  TLabel                 rcvdDB1;
char rcvdDB1_Caption[3] = "--";

  TLabel                 rcvdDB2;
char rcvdDB2_Caption[3] = "--";

  TLabel                 rcvdDB3;
char rcvdDB3_Caption[3] = "--";

  TLabel                 rcvdDB4;
char rcvdDB4_Caption[3] = "--";

  TLabel                 rcvdDB5;
char rcvdDB5_Caption[3] = "--";

  TLabel                 rcvdDB6;
char rcvdDB6_Caption[3] = "--";

  TLabel                 rcvdDB7;
char rcvdDB7_Caption[3] = "--";

  TCircle                CANTXIndicator;
  TLabel                 l_CANTX;
char l_CANTX_Caption[7] = "CAN Tx";

  TLabel                 Label5;
char Label5_Caption[21] = "received CAN message";

  TLine                  Line1;
  TImage               Image1;
  TLabel                 Label6;
char Label6_Caption[18] = "(by Jack Eberson)";

  TImage               info_button;
  TBox                   l_blinkspeed_red_box;
  TBox                   l_blinkspeed_green_box;
  TBox                   l_blinkspeed_blue_box;
  TLabel                 l_blinkspeed_red;
char l_blinkspeed_red_Caption[51] = "5";

  TLabel                 l_blinkspeed_green;
char l_blinkspeed_green_Caption[51] = "5";

  TLabel                 l_blinkspeed_blue;
char l_blinkspeed_blue_Caption[51] = "5";

  TLabel                 Label33;
char Label33_Caption[4] = "RED";

  TLabel                 Label34;
char Label34_Caption[6] = "GREEN";

  TLabel                 Label35;
char Label35_Caption[5] = "BLUE";

  TLabel                 Label36;
char Label36_Caption[12] = "BLINK SPEED";

  TLine                  Line3;
  TLabel                 Label37;
char Label37_Caption[32] = "(tap a field to edit the value)";

  TButton                * const code home_Buttons[9]=
         {
         &bRedOn,              
         &bRedOff,             
         &bGreenOn,            
         &bGreenOff,           
         &bBlueOn,             
         &bBlueOff,            
         &bRedBlink,           
         &bGreenBlink,         
         &bBlueBlink           
         };
  TLabel                 * const code home_Labels[26]=
         {
         &MainLabel,           
         &l_ID,                
         &l_DLC,               
         &l_DATA,              
         &l_CANRX,             
         &rcvdID,              
         &rcvdDLC,             
         &rcvdDB0,             
         &rcvdDB1,             
         &rcvdDB2,             
         &rcvdDB3,             
         &rcvdDB4,             
         &rcvdDB5,             
         &rcvdDB6,             
         &rcvdDB7,             
         &l_CANTX,             
         &Label5,              
         &Label6,              
         &l_blinkspeed_red,    
         &l_blinkspeed_green,  
         &l_blinkspeed_blue,   
         &Label33,             
         &Label34,             
         &Label35,             
         &Label36,             
         &Label37              
         };
  TImage                 * const code home_Images[2]=
         {
         &Image1,              
         &info_button          
         };
  TCircle                * const code home_Circles[5]=
         {
         &LedRedIndicator,     
         &LedGreenIndicator,   
         &LedBlueIndicator,    
         &CANRXIndicator,      
         &CANTXIndicator       
         };
  TBox                   * const code home_Boxes[5]=
         {
         &Box1,                
         &dynamicbox_1,        
         &l_blinkspeed_red_box,
         &l_blinkspeed_green_box,
         &l_blinkspeed_blue_box
         };
  TLine                  * const code home_Lines[3]=
         {
         &TopLine,             
         &Line1,               
         &Line3                
         };

  TScreen                help_screen;
  TLabel                 Label7;
char Label7_Caption[13] = "CAN commands";

  TLabel                 Label8;
char Label8_Caption[3] = "ID";

  TLabel                 Label9;
char Label9_Caption[11] = "parameters";

  TLabel                 Label10;
char Label10_Caption[7] = "remark";

  TLine                  Line2;
  TLabel                 Label11;
char Label11_Caption[5] = "AFF0";

  TLabel                 Label12;
char Label12_Caption[7] = "<none>";

  TLabel                 Label13;
char Label13_Caption[18] = "reset to defaults";

  TLabel                 Label14;
char Label14_Caption[5] = "AFF1";

  TLabel                 Label15;
char Label15_Caption[10] = "B0: speed";

  TLabel                 Label16;
char Label16_Caption[45] = "setup blinking speed for the red led (1..25)";

  TLabel                 Label20;
char Label20_Caption[5] = "AFF2";

  TLabel                 Label21;
char Label21_Caption[10] = "B0: speed";

  TLabel                 Label22;
char Label22_Caption[47] = "setup blinking speed for the green led (1..25)";

  TLabel                 Label23;
char Label23_Caption[5] = "AFF3";

  TLabel                 Label24;
char Label24_Caption[10] = "B0: speed";

  TLabel                 Label25;
char Label25_Caption[46] = "setup blinking speed for the blue led (1..25)";

  TBox                   Box2;
  TImage               help1_backbutton;
  TLabel                 Label17;
char Label17_Caption[7] = "notes:";

  TLabel                 Label18;
char Label18_Caption[21] = "CAN speed is 250kb/s";

  TLabel                 Label19;
char Label19_Caption[28] = "CAN frames: extended format";

  TLabel                 Label26;
char Label26_Caption[9] = "CAN INFO";

  TLabel                 Label1;
char Label1_Caption[5] = "AF00";

  TLabel                 Label2;
char Label2_Caption[11] = "B0, B1, B2";

  TLabel                 Label3;
char Label3_Caption[39] = "speed value: B0:red, B1:green, B2:blue";

  TLabel                 Label4;
char Label4_Caption[6] = "Tx/Rx";

  TLabel                 Label27;
char Label27_Caption[3] = "Rx";

  TLabel                 Label28;
char Label28_Caption[3] = "Rx";

  TLabel                 Label29;
char Label29_Caption[3] = "Rx";

  TLabel                 Label30;
char Label30_Caption[3] = "Rx";

  TLabel                 Label31;
char Label31_Caption[3] = "Tx";

  TLabel                 Label32;
char Label32_Caption[59] = "speed value message AF00 is being transmitted every second";

  TLabel                 * const code help_screen_Labels[30]=
         {
         &Label7,              
         &Label8,              
         &Label9,              
         &Label10,             
         &Label11,             
         &Label12,             
         &Label13,             
         &Label14,             
         &Label15,             
         &Label16,             
         &Label20,             
         &Label21,             
         &Label22,             
         &Label23,             
         &Label24,             
         &Label25,             
         &Label17,             
         &Label18,             
         &Label19,             
         &Label26,             
         &Label1,              
         &Label2,              
         &Label3,              
         &Label4,              
         &Label27,             
         &Label28,             
         &Label29,             
         &Label30,             
         &Label31,             
         &Label32              
         };
  TImage                 * const code help_screen_Images[1]=
         {
         &help1_backbutton     
         };
  TBox                   * const code help_screen_Boxes[1]=
         {
         &Box2                 
         };
  TLine                  * const code help_screen_Lines[1]=
         {
         &Line2                
         };

  TScreen                ValueInputScreen;
  TButton               Button_7;
char Button_7_Caption[2] = "7";

  TButton               Button_4;
char Button_4_Caption[2] = "4";

  TButton               Button_1;
char Button_1_Caption[2] = "1";

  TButton               Button_0;
char Button_0_Caption[2] = "0";

  TButton               Button_8;
char Button_8_Caption[2] = "8";

  TButton               Button_5;
char Button_5_Caption[2] = "5";

  TButton               Button_2;
char Button_2_Caption[2] = "2";

  TBox                   top_bar;
  TButton_Round          Button_close;
char Button_close_Caption[2] = "X";

  TButton               Button_plusminus;
char Button_plusminus_Caption[4] = "+/-";

  TButton               Button_9;
char Button_9_Caption[2] = "9";

  TImage               Button_clear;
  TBox_Round             BoxRound1;
  TBox_Round             BoxRound3;
  TImage               Button_accept;
  TBox_Round             BoxRound6;
  TImage               Button_backspace;
  TButton               Button_dot;
char Button_dot_Caption[2] = ".";

  TButton               Button_6;
char Button_6_Caption[2] = "6";

  TButton               Button_3;
char Button_3_Caption[2] = "3";

  TBox_Round             BoxRound2;
  TBox_Round             BoxRound4;
  TBox_Round             BoxRound7;
  TBox_Round             Box_display;
  TLabel                 l_input_value_text;
char l_input_value_text_Caption[101] = "enter a value for label: ----------";

  TLabel                 l_input_value_min;
char l_input_value_min_Caption[101] = "min. value: ----";

  TLabel                 l_input_value_max;
char l_input_value_max_Caption[101] = "max. value: ----";

  TLabel                 l_ValueInDisplay;
char l_ValueInDisplay_Caption[51] = "_";

  TButton                * const code ValueInputScreen_Buttons[12]=
         {
         &Button_7,            
         &Button_4,            
         &Button_1,            
         &Button_0,            
         &Button_8,            
         &Button_5,            
         &Button_2,            
         &Button_plusminus,    
         &Button_9,            
         &Button_dot,          
         &Button_6,            
         &Button_3             
         };
  TButton_Round          * const code ValueInputScreen_Buttons_Round[1]=
         {
         &Button_close         
         };
  TLabel                 * const code ValueInputScreen_Labels[4]=
         {
         &l_input_value_text,  
         &l_input_value_min,   
         &l_input_value_max,   
         &l_ValueInDisplay     
         };
  TImage                 * const code ValueInputScreen_Images[3]=
         {
         &Button_clear,        
         &Button_accept,       
         &Button_backspace     
         };
  TBox                   * const code ValueInputScreen_Boxes[1]=
         {
         &top_bar              
         };
  TBox_Round             * const code ValueInputScreen_Boxes_Round[7]=
         {
         &BoxRound1,           
         &BoxRound3,           
         &BoxRound6,           
         &BoxRound2,           
         &BoxRound4,           
         &BoxRound7,           
         &Box_display          
         };



static void InitializeObjects() {
  home.Color                     = 0x0418;
  home.Width                     = 480;
  home.Height                    = 272;
  home.ButtonsCount              = 9;
  home.Buttons                   = home_Buttons;
  home.Buttons_RoundCount        = 0;
  home.LabelsCount               = 26;
  home.Labels                    = home_Labels;
  home.ImagesCount               = 2;
  home.Images                    = home_Images;
  home.CirclesCount              = 5;
  home.Circles                   = home_Circles;
  home.BoxesCount                = 5;
  home.Boxes                     = home_Boxes;
  home.Boxes_RoundCount          = 0;
  home.LinesCount                = 3;
  home.Lines                     = home_Lines;
  home.ObjectsCount              = 50;

  help_screen.Color                     = 0xFFF9;
  help_screen.Width                     = 480;
  help_screen.Height                    = 272;
  help_screen.ButtonsCount              = 0;
  help_screen.Buttons_RoundCount        = 0;
  help_screen.LabelsCount               = 30;
  help_screen.Labels                    = help_screen_Labels;
  help_screen.ImagesCount               = 1;
  help_screen.Images                    = help_screen_Images;
  help_screen.CirclesCount              = 0;
  help_screen.BoxesCount                = 1;
  help_screen.Boxes                     = help_screen_Boxes;
  help_screen.Boxes_RoundCount          = 0;
  help_screen.LinesCount                = 1;
  help_screen.Lines                     = help_screen_Lines;
  help_screen.ObjectsCount              = 33;

  ValueInputScreen.Color                     = 0x0000;
  ValueInputScreen.Width                     = 480;
  ValueInputScreen.Height                    = 272;
  ValueInputScreen.ButtonsCount              = 12;
  ValueInputScreen.Buttons                   = ValueInputScreen_Buttons;
  ValueInputScreen.Buttons_RoundCount        = 1;
  ValueInputScreen.Buttons_Round             = ValueInputScreen_Buttons_Round;
  ValueInputScreen.LabelsCount               = 4;
  ValueInputScreen.Labels                    = ValueInputScreen_Labels;
  ValueInputScreen.ImagesCount               = 3;
  ValueInputScreen.Images                    = ValueInputScreen_Images;
  ValueInputScreen.CirclesCount              = 0;
  ValueInputScreen.BoxesCount                = 1;
  ValueInputScreen.Boxes                     = ValueInputScreen_Boxes;
  ValueInputScreen.Boxes_RoundCount          = 7;
  ValueInputScreen.Boxes_Round               = ValueInputScreen_Boxes_Round;
  ValueInputScreen.LinesCount                = 0;
  ValueInputScreen.ObjectsCount              = 28;


  Box1.OwnerScreen     = &home;
  Box1.Order           = 0;
  Box1.Left            = 7;
  Box1.Top             = 211;
  Box1.Width           = 465;
  Box1.Height          = 54;
  Box1.Pen_Width       = 1;
  Box1.Pen_Color       = 0x0000;
  Box1.Visible         = 1;
  Box1.Active          = 1;
  Box1.Transparent     = 1;
  Box1.Gradient        = 1;
  Box1.Gradient_Orientation = 0;
  Box1.Gradient_Start_Color = 0xFFFF;
  Box1.Gradient_End_Color = 0xC618;
  Box1.Color           = 0xFFFF;
  Box1.PressColEnabled = 1;
  Box1.Press_Color     = 0xE71C;
  Box1.OnUpPtr         = 0;
  Box1.OnDownPtr       = 0;
  Box1.OnClickPtr      = 0;
  Box1.OnPressPtr      = 0;

  MainLabel.OwnerScreen     = &home;
  MainLabel.Order           = 1;
  MainLabel.Left            = 20;
  MainLabel.Top             = 11;
  MainLabel.Width           = 170;
  MainLabel.Height          = 23;
  MainLabel.Visible         = 1;
  MainLabel.Active          = 1;
  MainLabel.Caption         = MainLabel_Caption;
  MainLabel.FontName        = Segoe_UI_Symbol16x21_Bold;
  MainLabel.Font_Color      = 0x0010;
  MainLabel.VerticalText    = 0;
  MainLabel.OnUpPtr         = 0;
  MainLabel.OnDownPtr       = 0;
  MainLabel.OnClickPtr      = 0;
  MainLabel.OnPressPtr      = 0;

  bRedOn.OwnerScreen     = &home;
  bRedOn.Order           = 2;
  bRedOn.Left            = 202;
  bRedOn.Top             = 41;
  bRedOn.Width           = 66;
  bRedOn.Height          = 18;
  bRedOn.Pen_Width       = 0;
  bRedOn.Pen_Color       = 0x0010;
  bRedOn.Visible         = 1;
  bRedOn.Active          = 1;
  bRedOn.Transparent     = 1;
  bRedOn.Caption         = bRedOn_Caption;
  bRedOn.TextAlign       = _taCenter;
  bRedOn.TextAlignVertical= _tavMiddle;
  bRedOn.FontName        = Tahoma11x13_Regular;
  bRedOn.PressColEnabled = 1;
  bRedOn.Font_Color      = 0x0000;
  bRedOn.VerticalText    = 0;
  bRedOn.Gradient        = 1;
  bRedOn.Gradient_Orientation = 0;
  bRedOn.Gradient_Start_Color = 0xFFFF;
  bRedOn.Gradient_End_Color = 0xC618;
  bRedOn.Color           = 0xC618;
  bRedOn.Press_Color     = 0xE71C;
  bRedOn.OnUpPtr         = 0;
  bRedOn.OnDownPtr       = 0;
  bRedOn.OnClickPtr      = 0;
  bRedOn.OnPressPtr      = RedOn;

  bRedOff.OwnerScreen     = &home;
  bRedOff.Order           = 3;
  bRedOff.Left            = 382;
  bRedOff.Top             = 41;
  bRedOff.Width           = 66;
  bRedOff.Height          = 18;
  bRedOff.Pen_Width       = 0;
  bRedOff.Pen_Color       = 0x0000;
  bRedOff.Visible         = 1;
  bRedOff.Active          = 1;
  bRedOff.Transparent     = 1;
  bRedOff.Caption         = bRedOff_Caption;
  bRedOff.TextAlign       = _taCenter;
  bRedOff.TextAlignVertical= _tavMiddle;
  bRedOff.FontName        = Tahoma11x13_Regular;
  bRedOff.PressColEnabled = 1;
  bRedOff.Font_Color      = 0x0000;
  bRedOff.VerticalText    = 0;
  bRedOff.Gradient        = 1;
  bRedOff.Gradient_Orientation = 0;
  bRedOff.Gradient_Start_Color = 0xFFFF;
  bRedOff.Gradient_End_Color = 0xC618;
  bRedOff.Color           = 0xC618;
  bRedOff.Press_Color     = 0xE71C;
  bRedOff.OnUpPtr         = 0;
  bRedOff.OnDownPtr       = 0;
  bRedOff.OnClickPtr      = 0;
  bRedOff.OnPressPtr      = RedOff;

  bGreenOn.OwnerScreen     = &home;
  bGreenOn.Order           = 4;
  bGreenOn.Left            = 202;
  bGreenOn.Top             = 73;
  bGreenOn.Width           = 66;
  bGreenOn.Height          = 18;
  bGreenOn.Pen_Width       = 0;
  bGreenOn.Pen_Color       = 0x0010;
  bGreenOn.Visible         = 1;
  bGreenOn.Active          = 1;
  bGreenOn.Transparent     = 1;
  bGreenOn.Caption         = bGreenOn_Caption;
  bGreenOn.TextAlign       = _taCenter;
  bGreenOn.TextAlignVertical= _tavMiddle;
  bGreenOn.FontName        = Tahoma11x13_Regular;
  bGreenOn.PressColEnabled = 1;
  bGreenOn.Font_Color      = 0x0000;
  bGreenOn.VerticalText    = 0;
  bGreenOn.Gradient        = 1;
  bGreenOn.Gradient_Orientation = 0;
  bGreenOn.Gradient_Start_Color = 0xFFFF;
  bGreenOn.Gradient_End_Color = 0xC618;
  bGreenOn.Color           = 0xC618;
  bGreenOn.Press_Color     = 0xE71C;
  bGreenOn.OnUpPtr         = 0;
  bGreenOn.OnDownPtr       = 0;
  bGreenOn.OnClickPtr      = 0;
  bGreenOn.OnPressPtr      = GreenOn;

  bGreenOff.OwnerScreen     = &home;
  bGreenOff.Order           = 5;
  bGreenOff.Left            = 382;
  bGreenOff.Top             = 73;
  bGreenOff.Width           = 66;
  bGreenOff.Height          = 18;
  bGreenOff.Pen_Width       = 0;
  bGreenOff.Pen_Color       = 0x0010;
  bGreenOff.Visible         = 1;
  bGreenOff.Active          = 1;
  bGreenOff.Transparent     = 1;
  bGreenOff.Caption         = bGreenOff_Caption;
  bGreenOff.TextAlign       = _taCenter;
  bGreenOff.TextAlignVertical= _tavMiddle;
  bGreenOff.FontName        = Tahoma11x13_Regular;
  bGreenOff.PressColEnabled = 1;
  bGreenOff.Font_Color      = 0x0000;
  bGreenOff.VerticalText    = 0;
  bGreenOff.Gradient        = 1;
  bGreenOff.Gradient_Orientation = 0;
  bGreenOff.Gradient_Start_Color = 0xFFFF;
  bGreenOff.Gradient_End_Color = 0xC618;
  bGreenOff.Color           = 0xC618;
  bGreenOff.Press_Color     = 0xE71C;
  bGreenOff.OnUpPtr         = 0;
  bGreenOff.OnDownPtr       = 0;
  bGreenOff.OnClickPtr      = 0;
  bGreenOff.OnPressPtr      = GreenOff;

  bBlueOn.OwnerScreen     = &home;
  bBlueOn.Order           = 6;
  bBlueOn.Left            = 202;
  bBlueOn.Top             = 105;
  bBlueOn.Width           = 66;
  bBlueOn.Height          = 18;
  bBlueOn.Pen_Width       = 0;
  bBlueOn.Pen_Color       = 0x0010;
  bBlueOn.Visible         = 1;
  bBlueOn.Active          = 1;
  bBlueOn.Transparent     = 1;
  bBlueOn.Caption         = bBlueOn_Caption;
  bBlueOn.TextAlign       = _taCenter;
  bBlueOn.TextAlignVertical= _tavMiddle;
  bBlueOn.FontName        = Tahoma11x13_Regular;
  bBlueOn.PressColEnabled = 1;
  bBlueOn.Font_Color      = 0x0000;
  bBlueOn.VerticalText    = 0;
  bBlueOn.Gradient        = 1;
  bBlueOn.Gradient_Orientation = 0;
  bBlueOn.Gradient_Start_Color = 0xFFFF;
  bBlueOn.Gradient_End_Color = 0xC618;
  bBlueOn.Color           = 0xC618;
  bBlueOn.Press_Color     = 0xE71C;
  bBlueOn.OnUpPtr         = 0;
  bBlueOn.OnDownPtr       = 0;
  bBlueOn.OnClickPtr      = 0;
  bBlueOn.OnPressPtr      = BlueOn;

  bBlueOff.OwnerScreen     = &home;
  bBlueOff.Order           = 7;
  bBlueOff.Left            = 382;
  bBlueOff.Top             = 105;
  bBlueOff.Width           = 66;
  bBlueOff.Height          = 18;
  bBlueOff.Pen_Width       = 0;
  bBlueOff.Pen_Color       = 0x0010;
  bBlueOff.Visible         = 1;
  bBlueOff.Active          = 1;
  bBlueOff.Transparent     = 1;
  bBlueOff.Caption         = bBlueOff_Caption;
  bBlueOff.TextAlign       = _taCenter;
  bBlueOff.TextAlignVertical= _tavMiddle;
  bBlueOff.FontName        = Tahoma11x13_Regular;
  bBlueOff.PressColEnabled = 1;
  bBlueOff.Font_Color      = 0x0000;
  bBlueOff.VerticalText    = 0;
  bBlueOff.Gradient        = 1;
  bBlueOff.Gradient_Orientation = 0;
  bBlueOff.Gradient_Start_Color = 0xFFFF;
  bBlueOff.Gradient_End_Color = 0xC618;
  bBlueOff.Color           = 0xC618;
  bBlueOff.Press_Color     = 0xE71C;
  bBlueOff.OnUpPtr         = 0;
  bBlueOff.OnDownPtr       = 0;
  bBlueOff.OnClickPtr      = 0;
  bBlueOff.OnPressPtr      = BlueOff;

  bRedBlink.OwnerScreen     = &home;
  bRedBlink.Order           = 8;
  bRedBlink.Left            = 290;
  bRedBlink.Top             = 41;
  bRedBlink.Width           = 69;
  bRedBlink.Height          = 18;
  bRedBlink.Pen_Width       = 0;
  bRedBlink.Pen_Color       = 0x0000;
  bRedBlink.Visible         = 1;
  bRedBlink.Active          = 1;
  bRedBlink.Transparent     = 1;
  bRedBlink.Caption         = bRedBlink_Caption;
  bRedBlink.TextAlign       = _taCenter;
  bRedBlink.TextAlignVertical= _tavMiddle;
  bRedBlink.FontName        = Tahoma11x13_Regular;
  bRedBlink.PressColEnabled = 1;
  bRedBlink.Font_Color      = 0x0000;
  bRedBlink.VerticalText    = 0;
  bRedBlink.Gradient        = 1;
  bRedBlink.Gradient_Orientation = 0;
  bRedBlink.Gradient_Start_Color = 0xFFFF;
  bRedBlink.Gradient_End_Color = 0xC618;
  bRedBlink.Color           = 0xC618;
  bRedBlink.Press_Color     = 0xE71C;
  bRedBlink.OnUpPtr         = 0;
  bRedBlink.OnDownPtr       = 0;
  bRedBlink.OnClickPtr      = 0;
  bRedBlink.OnPressPtr      = RedBlink;

  bGreenBlink.OwnerScreen     = &home;
  bGreenBlink.Order           = 9;
  bGreenBlink.Left            = 290;
  bGreenBlink.Top             = 73;
  bGreenBlink.Width           = 69;
  bGreenBlink.Height          = 18;
  bGreenBlink.Pen_Width       = 0;
  bGreenBlink.Pen_Color       = 0x0010;
  bGreenBlink.Visible         = 1;
  bGreenBlink.Active          = 1;
  bGreenBlink.Transparent     = 1;
  bGreenBlink.Caption         = bGreenBlink_Caption;
  bGreenBlink.TextAlign       = _taCenter;
  bGreenBlink.TextAlignVertical= _tavMiddle;
  bGreenBlink.FontName        = Tahoma11x13_Regular;
  bGreenBlink.PressColEnabled = 1;
  bGreenBlink.Font_Color      = 0x0000;
  bGreenBlink.VerticalText    = 0;
  bGreenBlink.Gradient        = 1;
  bGreenBlink.Gradient_Orientation = 0;
  bGreenBlink.Gradient_Start_Color = 0xFFFF;
  bGreenBlink.Gradient_End_Color = 0xC618;
  bGreenBlink.Color           = 0xC618;
  bGreenBlink.Press_Color     = 0xE71C;
  bGreenBlink.OnUpPtr         = 0;
  bGreenBlink.OnDownPtr       = 0;
  bGreenBlink.OnClickPtr      = 0;
  bGreenBlink.OnPressPtr      = GreenBlink;

  bBlueBlink.OwnerScreen     = &home;
  bBlueBlink.Order           = 10;
  bBlueBlink.Left            = 290;
  bBlueBlink.Top             = 105;
  bBlueBlink.Width           = 69;
  bBlueBlink.Height          = 18;
  bBlueBlink.Pen_Width       = 0;
  bBlueBlink.Pen_Color       = 0x0010;
  bBlueBlink.Visible         = 1;
  bBlueBlink.Active          = 1;
  bBlueBlink.Transparent     = 1;
  bBlueBlink.Caption         = bBlueBlink_Caption;
  bBlueBlink.TextAlign       = _taCenter;
  bBlueBlink.TextAlignVertical= _tavMiddle;
  bBlueBlink.FontName        = Tahoma11x13_Regular;
  bBlueBlink.PressColEnabled = 1;
  bBlueBlink.Font_Color      = 0x0000;
  bBlueBlink.VerticalText    = 0;
  bBlueBlink.Gradient        = 1;
  bBlueBlink.Gradient_Orientation = 0;
  bBlueBlink.Gradient_Start_Color = 0xFFFF;
  bBlueBlink.Gradient_End_Color = 0xC618;
  bBlueBlink.Color           = 0xC618;
  bBlueBlink.Press_Color     = 0xE71C;
  bBlueBlink.OnUpPtr         = 0;
  bBlueBlink.OnDownPtr       = 0;
  bBlueBlink.OnClickPtr      = 0;
  bBlueBlink.OnPressPtr      = BlueBlink;

  TopLine.OwnerScreen     = &home;
  TopLine.Order           = 11;
  TopLine.First_Point_X   = 10;
  TopLine.First_Point_Y   = 33;
  TopLine.Second_Point_X  = 470;
  TopLine.Second_Point_Y  = 33;
  TopLine.Visible         = 1;
  TopLine.Pen_Width       = 2;
  TopLine.Color           = 0x0010;

  LedRedIndicator.OwnerScreen     = &home;
  LedRedIndicator.Order           = 12;
  LedRedIndicator.Left            = 166;
  LedRedIndicator.Top             = 42;
  LedRedIndicator.Radius          = 8;
  LedRedIndicator.Pen_Width       = 1;
  LedRedIndicator.Pen_Color       = 0xF800;
  LedRedIndicator.Visible         = 1;
  LedRedIndicator.Active          = 1;
  LedRedIndicator.Transparent     = 0;
  LedRedIndicator.Gradient        = 0;
  LedRedIndicator.Gradient_Orientation = 0;
  LedRedIndicator.Gradient_Start_Color = 0xFFFF;
  LedRedIndicator.Gradient_End_Color = 0xC618;
  LedRedIndicator.Color           = 0xF800;
  LedRedIndicator.PressColEnabled = 0;
  LedRedIndicator.Press_Color     = 0xE71C;
  LedRedIndicator.OnUpPtr         = 0;
  LedRedIndicator.OnDownPtr       = 0;
  LedRedIndicator.OnClickPtr      = 0;
  LedRedIndicator.OnPressPtr      = 0;

  LedGreenIndicator.OwnerScreen     = &home;
  LedGreenIndicator.Order           = 13;
  LedGreenIndicator.Left            = 166;
  LedGreenIndicator.Top             = 74;
  LedGreenIndicator.Radius          = 8;
  LedGreenIndicator.Pen_Width       = 1;
  LedGreenIndicator.Pen_Color       = 0x07E0;
  LedGreenIndicator.Visible         = 1;
  LedGreenIndicator.Active          = 1;
  LedGreenIndicator.Transparent     = 0;
  LedGreenIndicator.Gradient        = 0;
  LedGreenIndicator.Gradient_Orientation = 0;
  LedGreenIndicator.Gradient_Start_Color = 0xFFFF;
  LedGreenIndicator.Gradient_End_Color = 0xC618;
  LedGreenIndicator.Color           = 0x07E0;
  LedGreenIndicator.PressColEnabled = 0;
  LedGreenIndicator.Press_Color     = 0xE71C;
  LedGreenIndicator.OnUpPtr         = 0;
  LedGreenIndicator.OnDownPtr       = 0;
  LedGreenIndicator.OnClickPtr      = 0;
  LedGreenIndicator.OnPressPtr      = 0;

  LedBlueIndicator.OwnerScreen     = &home;
  LedBlueIndicator.Order           = 14;
  LedBlueIndicator.Left            = 166;
  LedBlueIndicator.Top             = 106;
  LedBlueIndicator.Radius          = 8;
  LedBlueIndicator.Pen_Width       = 1;
  LedBlueIndicator.Pen_Color       = 0x001F;
  LedBlueIndicator.Visible         = 1;
  LedBlueIndicator.Active          = 1;
  LedBlueIndicator.Transparent     = 0;
  LedBlueIndicator.Gradient        = 0;
  LedBlueIndicator.Gradient_Orientation = 0;
  LedBlueIndicator.Gradient_Start_Color = 0xFFFF;
  LedBlueIndicator.Gradient_End_Color = 0xC618;
  LedBlueIndicator.Color           = 0x001F;
  LedBlueIndicator.PressColEnabled = 0;
  LedBlueIndicator.Press_Color     = 0xE71C;
  LedBlueIndicator.OnUpPtr         = 0;
  LedBlueIndicator.OnDownPtr       = 0;
  LedBlueIndicator.OnClickPtr      = 0;
  LedBlueIndicator.OnPressPtr      = 0;

  l_ID.OwnerScreen     = &home;
  l_ID.Order           = 15;
  l_ID.Left            = 261;
  l_ID.Top             = 216;
  l_ID.Width           = 20;
  l_ID.Height          = 15;
  l_ID.Visible         = 1;
  l_ID.Active          = 1;
  l_ID.Caption         = l_ID_Caption;
  l_ID.FontName        = Tahoma11x13_Regular;
  l_ID.Font_Color      = 0x0010;
  l_ID.VerticalText    = 0;
  l_ID.OnUpPtr         = 0;
  l_ID.OnDownPtr       = 0;
  l_ID.OnClickPtr      = 0;
  l_ID.OnPressPtr      = 0;

  l_DLC.OwnerScreen     = &home;
  l_DLC.Order           = 16;
  l_DLC.Left            = 253;
  l_DLC.Top             = 231;
  l_DLC.Width           = 28;
  l_DLC.Height          = 15;
  l_DLC.Visible         = 1;
  l_DLC.Active          = 1;
  l_DLC.Caption         = l_DLC_Caption;
  l_DLC.FontName        = Tahoma11x13_Regular;
  l_DLC.Font_Color      = 0x0010;
  l_DLC.VerticalText    = 0;
  l_DLC.OnUpPtr         = 0;
  l_DLC.OnDownPtr       = 0;
  l_DLC.OnClickPtr      = 0;
  l_DLC.OnPressPtr      = 0;

  l_DATA.OwnerScreen     = &home;
  l_DATA.Order           = 17;
  l_DATA.Left            = 245;
  l_DATA.Top             = 247;
  l_DATA.Width           = 36;
  l_DATA.Height          = 15;
  l_DATA.Visible         = 1;
  l_DATA.Active          = 1;
  l_DATA.Caption         = l_DATA_Caption;
  l_DATA.FontName        = Tahoma11x13_Regular;
  l_DATA.Font_Color      = 0x0010;
  l_DATA.VerticalText    = 0;
  l_DATA.OnUpPtr         = 0;
  l_DATA.OnDownPtr       = 0;
  l_DATA.OnClickPtr      = 0;
  l_DATA.OnPressPtr      = 0;

  CANRXIndicator.OwnerScreen     = &home;
  CANRXIndicator.Order           = 18;
  CANRXIndicator.Left            = 15;
  CANRXIndicator.Top             = 241;
  CANRXIndicator.Radius          = 8;
  CANRXIndicator.Pen_Width       = 1;
  CANRXIndicator.Pen_Color       = 0xFFE0;
  CANRXIndicator.Visible         = 1;
  CANRXIndicator.Active          = 1;
  CANRXIndicator.Transparent     = 0;
  CANRXIndicator.Gradient        = 0;
  CANRXIndicator.Gradient_Orientation = 0;
  CANRXIndicator.Gradient_Start_Color = 0xFFFF;
  CANRXIndicator.Gradient_End_Color = 0xC618;
  CANRXIndicator.Color           = 0xFFE0;
  CANRXIndicator.PressColEnabled = 0;
  CANRXIndicator.Press_Color     = 0xE71C;
  CANRXIndicator.OnUpPtr         = 0;
  CANRXIndicator.OnDownPtr       = 0;
  CANRXIndicator.OnClickPtr      = 0;
  CANRXIndicator.OnPressPtr      = 0;

  l_CANRX.OwnerScreen     = &home;
  l_CANRX.Order           = 19;
  l_CANRX.Left            = 37;
  l_CANRX.Top             = 243;
  l_CANRX.Width           = 41;
  l_CANRX.Height          = 15;
  l_CANRX.Visible         = 1;
  l_CANRX.Active          = 1;
  l_CANRX.Caption         = l_CANRX_Caption;
  l_CANRX.FontName        = Tahoma11x13_Regular;
  l_CANRX.Font_Color      = 0x0010;
  l_CANRX.VerticalText    = 0;
  l_CANRX.OnUpPtr         = 0;
  l_CANRX.OnDownPtr       = 0;
  l_CANRX.OnClickPtr      = 0;
  l_CANRX.OnPressPtr      = 0;

  dynamicbox_1.OwnerScreen     = &home;
  dynamicbox_1.Order           = 20;
  dynamicbox_1.Left            = 279;
  dynamicbox_1.Top             = 212;
  dynamicbox_1.Width           = 180;
  dynamicbox_1.Height          = 52;
  dynamicbox_1.Pen_Width       = 0;
  dynamicbox_1.Pen_Color       = 0x0000;
  dynamicbox_1.Visible         = 1;
  dynamicbox_1.Active          = 1;
  dynamicbox_1.Transparent     = 1;
  dynamicbox_1.Gradient        = 1;
  dynamicbox_1.Gradient_Orientation = 0;
  dynamicbox_1.Gradient_Start_Color = 0xFFFF;
  dynamicbox_1.Gradient_End_Color = 0xC618;
  dynamicbox_1.Color           = 0xC618;
  dynamicbox_1.PressColEnabled = 0;
  dynamicbox_1.Press_Color     = 0xE71C;
  dynamicbox_1.OnUpPtr         = 0;
  dynamicbox_1.OnDownPtr       = 0;
  dynamicbox_1.OnClickPtr      = 0;
  dynamicbox_1.OnPressPtr      = 0;

  rcvdID.OwnerScreen     = &home;
  rcvdID.Order           = 21;
  rcvdID.Left            = 281;
  rcvdID.Top             = 216;
  rcvdID.Width           = 12;
  rcvdID.Height          = 15;
  rcvdID.Visible         = 1;
  rcvdID.Active          = 1;
  rcvdID.Caption         = rcvdID_Caption;
  rcvdID.FontName        = Tahoma11x13_Regular;
  rcvdID.Font_Color      = 0x0010;
  rcvdID.VerticalText    = 0;
  rcvdID.OnUpPtr         = 0;
  rcvdID.OnDownPtr       = 0;
  rcvdID.OnClickPtr      = 0;
  rcvdID.OnPressPtr      = 0;

  rcvdDLC.OwnerScreen     = &home;
  rcvdDLC.Order           = 22;
  rcvdDLC.Left            = 281;
  rcvdDLC.Top             = 231;
  rcvdDLC.Width           = 12;
  rcvdDLC.Height          = 15;
  rcvdDLC.Visible         = 1;
  rcvdDLC.Active          = 1;
  rcvdDLC.Caption         = rcvdDLC_Caption;
  rcvdDLC.FontName        = Tahoma11x13_Regular;
  rcvdDLC.Font_Color      = 0x0010;
  rcvdDLC.VerticalText    = 0;
  rcvdDLC.OnUpPtr         = 0;
  rcvdDLC.OnDownPtr       = 0;
  rcvdDLC.OnClickPtr      = 0;
  rcvdDLC.OnPressPtr      = 0;

  rcvdDB0.OwnerScreen     = &home;
  rcvdDB0.Order           = 23;
  rcvdDB0.Left            = 281;
  rcvdDB0.Top             = 247;
  rcvdDB0.Width           = 12;
  rcvdDB0.Height          = 15;
  rcvdDB0.Visible         = 1;
  rcvdDB0.Active          = 1;
  rcvdDB0.Caption         = rcvdDB0_Caption;
  rcvdDB0.FontName        = Tahoma11x13_Regular;
  rcvdDB0.Font_Color      = 0x0010;
  rcvdDB0.VerticalText    = 0;
  rcvdDB0.OnUpPtr         = 0;
  rcvdDB0.OnDownPtr       = 0;
  rcvdDB0.OnClickPtr      = 0;
  rcvdDB0.OnPressPtr      = 0;

  rcvdDB1.OwnerScreen     = &home;
  rcvdDB1.Order           = 24;
  rcvdDB1.Left            = 304;
  rcvdDB1.Top             = 247;
  rcvdDB1.Width           = 12;
  rcvdDB1.Height          = 15;
  rcvdDB1.Visible         = 1;
  rcvdDB1.Active          = 1;
  rcvdDB1.Caption         = rcvdDB1_Caption;
  rcvdDB1.FontName        = Tahoma11x13_Regular;
  rcvdDB1.Font_Color      = 0x0010;
  rcvdDB1.VerticalText    = 0;
  rcvdDB1.OnUpPtr         = 0;
  rcvdDB1.OnDownPtr       = 0;
  rcvdDB1.OnClickPtr      = 0;
  rcvdDB1.OnPressPtr      = 0;

  rcvdDB2.OwnerScreen     = &home;
  rcvdDB2.Order           = 25;
  rcvdDB2.Left            = 327;
  rcvdDB2.Top             = 247;
  rcvdDB2.Width           = 12;
  rcvdDB2.Height          = 15;
  rcvdDB2.Visible         = 1;
  rcvdDB2.Active          = 1;
  rcvdDB2.Caption         = rcvdDB2_Caption;
  rcvdDB2.FontName        = Tahoma11x13_Regular;
  rcvdDB2.Font_Color      = 0x0010;
  rcvdDB2.VerticalText    = 0;
  rcvdDB2.OnUpPtr         = 0;
  rcvdDB2.OnDownPtr       = 0;
  rcvdDB2.OnClickPtr      = 0;
  rcvdDB2.OnPressPtr      = 0;

  rcvdDB3.OwnerScreen     = &home;
  rcvdDB3.Order           = 26;
  rcvdDB3.Left            = 350;
  rcvdDB3.Top             = 247;
  rcvdDB3.Width           = 12;
  rcvdDB3.Height          = 15;
  rcvdDB3.Visible         = 1;
  rcvdDB3.Active          = 1;
  rcvdDB3.Caption         = rcvdDB3_Caption;
  rcvdDB3.FontName        = Tahoma11x13_Regular;
  rcvdDB3.Font_Color      = 0x0010;
  rcvdDB3.VerticalText    = 0;
  rcvdDB3.OnUpPtr         = 0;
  rcvdDB3.OnDownPtr       = 0;
  rcvdDB3.OnClickPtr      = 0;
  rcvdDB3.OnPressPtr      = 0;

  rcvdDB4.OwnerScreen     = &home;
  rcvdDB4.Order           = 27;
  rcvdDB4.Left            = 374;
  rcvdDB4.Top             = 247;
  rcvdDB4.Width           = 12;
  rcvdDB4.Height          = 15;
  rcvdDB4.Visible         = 1;
  rcvdDB4.Active          = 1;
  rcvdDB4.Caption         = rcvdDB4_Caption;
  rcvdDB4.FontName        = Tahoma11x13_Regular;
  rcvdDB4.Font_Color      = 0x0010;
  rcvdDB4.VerticalText    = 0;
  rcvdDB4.OnUpPtr         = 0;
  rcvdDB4.OnDownPtr       = 0;
  rcvdDB4.OnClickPtr      = 0;
  rcvdDB4.OnPressPtr      = 0;

  rcvdDB5.OwnerScreen     = &home;
  rcvdDB5.Order           = 28;
  rcvdDB5.Left            = 397;
  rcvdDB5.Top             = 247;
  rcvdDB5.Width           = 12;
  rcvdDB5.Height          = 15;
  rcvdDB5.Visible         = 1;
  rcvdDB5.Active          = 1;
  rcvdDB5.Caption         = rcvdDB5_Caption;
  rcvdDB5.FontName        = Tahoma11x13_Regular;
  rcvdDB5.Font_Color      = 0x0010;
  rcvdDB5.VerticalText    = 0;
  rcvdDB5.OnUpPtr         = 0;
  rcvdDB5.OnDownPtr       = 0;
  rcvdDB5.OnClickPtr      = 0;
  rcvdDB5.OnPressPtr      = 0;

  rcvdDB6.OwnerScreen     = &home;
  rcvdDB6.Order           = 29;
  rcvdDB6.Left            = 420;
  rcvdDB6.Top             = 247;
  rcvdDB6.Width           = 12;
  rcvdDB6.Height          = 15;
  rcvdDB6.Visible         = 1;
  rcvdDB6.Active          = 1;
  rcvdDB6.Caption         = rcvdDB6_Caption;
  rcvdDB6.FontName        = Tahoma11x13_Regular;
  rcvdDB6.Font_Color      = 0x0010;
  rcvdDB6.VerticalText    = 0;
  rcvdDB6.OnUpPtr         = 0;
  rcvdDB6.OnDownPtr       = 0;
  rcvdDB6.OnClickPtr      = 0;
  rcvdDB6.OnPressPtr      = 0;

  rcvdDB7.OwnerScreen     = &home;
  rcvdDB7.Order           = 30;
  rcvdDB7.Left            = 443;
  rcvdDB7.Top             = 247;
  rcvdDB7.Width           = 12;
  rcvdDB7.Height          = 15;
  rcvdDB7.Visible         = 1;
  rcvdDB7.Active          = 1;
  rcvdDB7.Caption         = rcvdDB7_Caption;
  rcvdDB7.FontName        = Tahoma11x13_Regular;
  rcvdDB7.Font_Color      = 0x0010;
  rcvdDB7.VerticalText    = 0;
  rcvdDB7.OnUpPtr         = 0;
  rcvdDB7.OnDownPtr       = 0;
  rcvdDB7.OnClickPtr      = 0;
  rcvdDB7.OnPressPtr      = 0;

  CANTXIndicator.OwnerScreen     = &home;
  CANTXIndicator.Order           = 31;
  CANTXIndicator.Left            = 15;
  CANTXIndicator.Top             = 219;
  CANTXIndicator.Radius          = 8;
  CANTXIndicator.Pen_Width       = 1;
  CANTXIndicator.Pen_Color       = 0xFFE0;
  CANTXIndicator.Visible         = 1;
  CANTXIndicator.Active          = 1;
  CANTXIndicator.Transparent     = 0;
  CANTXIndicator.Gradient        = 0;
  CANTXIndicator.Gradient_Orientation = 0;
  CANTXIndicator.Gradient_Start_Color = 0xFFFF;
  CANTXIndicator.Gradient_End_Color = 0xC618;
  CANTXIndicator.Color           = 0xFFE0;
  CANTXIndicator.PressColEnabled = 0;
  CANTXIndicator.Press_Color     = 0xE71C;
  CANTXIndicator.OnUpPtr         = 0;
  CANTXIndicator.OnDownPtr       = 0;
  CANTXIndicator.OnClickPtr      = 0;
  CANTXIndicator.OnPressPtr      = 0;

  l_CANTX.OwnerScreen     = &home;
  l_CANTX.Order           = 32;
  l_CANTX.Left            = 37;
  l_CANTX.Top             = 221;
  l_CANTX.Width           = 41;
  l_CANTX.Height          = 15;
  l_CANTX.Visible         = 1;
  l_CANTX.Active          = 1;
  l_CANTX.Caption         = l_CANTX_Caption;
  l_CANTX.FontName        = Tahoma11x13_Regular;
  l_CANTX.Font_Color      = 0x0010;
  l_CANTX.VerticalText    = 0;
  l_CANTX.OnUpPtr         = 0;
  l_CANTX.OnDownPtr       = 0;
  l_CANTX.OnClickPtr      = 0;
  l_CANTX.OnPressPtr      = 0;

  Label5.OwnerScreen     = &home;
  Label5.Order           = 33;
  Label5.Left            = 112;
  Label5.Top             = 216;
  Label5.Width           = 128;
  Label5.Height          = 16;
  Label5.Visible         = 1;
  Label5.Active          = 1;
  Label5.Caption         = Label5_Caption;
  Label5.FontName        = Tahoma12x14_Regular;
  Label5.Font_Color      = 0x0010;
  Label5.VerticalText    = 0;
  Label5.OnUpPtr         = 0;
  Label5.OnDownPtr       = 0;
  Label5.OnClickPtr      = 0;
  Label5.OnPressPtr      = 0;

  Line1.OwnerScreen     = &home;
  Line1.Order           = 34;
  Line1.First_Point_X   = 91;
  Line1.First_Point_Y   = 214;
  Line1.Second_Point_X  = 91;
  Line1.Second_Point_Y  = 262;
  Line1.Visible         = 1;
  Line1.Pen_Width       = 2;
  Line1.Color           = 0x0010;

  Image1.OwnerScreen     = &home;
  Image1.Order           = 35;
  Image1.Left            = 40;
  Image1.Top             = 38;
  Image1.Width           = 100;
  Image1.Height          = 100;
  Image1.Picture_Type    = 0;
  Image1.Picture_Ratio   = 1;
  Image1.Picture_Name    = RGBled_bmp;
  Image1.Visible         = 1;
  Image1.Active          = 1;
  Image1.OnUpPtr         = 0;
  Image1.OnDownPtr       = 0;
  Image1.OnClickPtr      = 0;
  Image1.OnPressPtr      = 0;

  Label6.OwnerScreen     = &home;
  Label6.Order           = 36;
  Label6.Left            = 356;
  Label6.Top             = 17;
  Label6.Width           = 104;
  Label6.Height          = 15;
  Label6.Visible         = 1;
  Label6.Active          = 1;
  Label6.Caption         = Label6_Caption;
  Label6.FontName        = Arial12x15_Regular;
  Label6.Font_Color      = 0x0010;
  Label6.VerticalText    = 0;
  Label6.OnUpPtr         = 0;
  Label6.OnDownPtr       = 0;
  Label6.OnClickPtr      = 0;
  Label6.OnPressPtr      = 0;

  info_button.OwnerScreen     = &home;
  info_button.Order           = 37;
  info_button.Left            = 421;
  info_button.Top             = 153;
  info_button.Width           = 50;
  info_button.Height          = 50;
  info_button.Picture_Type    = 0;
  info_button.Picture_Ratio   = 1;
  info_button.Picture_Name    = infobutton_bmp;
  info_button.Visible         = 1;
  info_button.Active          = 1;
  info_button.OnUpPtr         = 0;
  info_button.OnDownPtr       = 0;
  info_button.OnClickPtr      = InfoScreen;
  info_button.OnPressPtr      = 0;

  l_blinkspeed_red_box.OwnerScreen     = &home;
  l_blinkspeed_red_box.Order           = 38;
  l_blinkspeed_red_box.Left            = 36;
  l_blinkspeed_red_box.Top             = 183;
  l_blinkspeed_red_box.Width           = 39;
  l_blinkspeed_red_box.Height          = 18;
  l_blinkspeed_red_box.Pen_Width       = 1;
  l_blinkspeed_red_box.Pen_Color       = 0x0000;
  l_blinkspeed_red_box.Visible         = 1;
  l_blinkspeed_red_box.Active          = 1;
  l_blinkspeed_red_box.Transparent     = 1;
  l_blinkspeed_red_box.Gradient        = 0;
  l_blinkspeed_red_box.Gradient_Orientation = 0;
  l_blinkspeed_red_box.Gradient_Start_Color = 0xFFFF;
  l_blinkspeed_red_box.Gradient_End_Color = 0xC618;
  l_blinkspeed_red_box.Color           = 0xC618;
  l_blinkspeed_red_box.PressColEnabled = 1;
  l_blinkspeed_red_box.Press_Color     = 0xE71C;
  l_blinkspeed_red_box.OnUpPtr         = 0;
  l_blinkspeed_red_box.OnDownPtr       = 0;
  l_blinkspeed_red_box.OnClickPtr      = SetBlinkingSpeedRed;
  l_blinkspeed_red_box.OnPressPtr      = 0;

  l_blinkspeed_green_box.OwnerScreen     = &home;
  l_blinkspeed_green_box.Order           = 39;
  l_blinkspeed_green_box.Left            = 124;
  l_blinkspeed_green_box.Top             = 183;
  l_blinkspeed_green_box.Width           = 39;
  l_blinkspeed_green_box.Height          = 18;
  l_blinkspeed_green_box.Pen_Width       = 1;
  l_blinkspeed_green_box.Pen_Color       = 0x0000;
  l_blinkspeed_green_box.Visible         = 1;
  l_blinkspeed_green_box.Active          = 1;
  l_blinkspeed_green_box.Transparent     = 1;
  l_blinkspeed_green_box.Gradient        = 0;
  l_blinkspeed_green_box.Gradient_Orientation = 0;
  l_blinkspeed_green_box.Gradient_Start_Color = 0xFFFF;
  l_blinkspeed_green_box.Gradient_End_Color = 0xC618;
  l_blinkspeed_green_box.Color           = 0xC618;
  l_blinkspeed_green_box.PressColEnabled = 1;
  l_blinkspeed_green_box.Press_Color     = 0xE71C;
  l_blinkspeed_green_box.OnUpPtr         = 0;
  l_blinkspeed_green_box.OnDownPtr       = 0;
  l_blinkspeed_green_box.OnClickPtr      = SetBlinkingSpeedGreen;
  l_blinkspeed_green_box.OnPressPtr      = 0;

  l_blinkspeed_blue_box.OwnerScreen     = &home;
  l_blinkspeed_blue_box.Order           = 40;
  l_blinkspeed_blue_box.Left            = 209;
  l_blinkspeed_blue_box.Top             = 183;
  l_blinkspeed_blue_box.Width           = 39;
  l_blinkspeed_blue_box.Height          = 18;
  l_blinkspeed_blue_box.Pen_Width       = 1;
  l_blinkspeed_blue_box.Pen_Color       = 0x0000;
  l_blinkspeed_blue_box.Visible         = 1;
  l_blinkspeed_blue_box.Active          = 1;
  l_blinkspeed_blue_box.Transparent     = 1;
  l_blinkspeed_blue_box.Gradient        = 0;
  l_blinkspeed_blue_box.Gradient_Orientation = 0;
  l_blinkspeed_blue_box.Gradient_Start_Color = 0xFFFF;
  l_blinkspeed_blue_box.Gradient_End_Color = 0xC618;
  l_blinkspeed_blue_box.Color           = 0xC618;
  l_blinkspeed_blue_box.PressColEnabled = 1;
  l_blinkspeed_blue_box.Press_Color     = 0xE71C;
  l_blinkspeed_blue_box.OnUpPtr         = 0;
  l_blinkspeed_blue_box.OnDownPtr       = 0;
  l_blinkspeed_blue_box.OnClickPtr      = SetBlinkingSpeedBlue;
  l_blinkspeed_blue_box.OnPressPtr      = 0;

  l_blinkspeed_red.OwnerScreen     = &home;
  l_blinkspeed_red.Order           = 41;
  l_blinkspeed_red.Left            = 41;
  l_blinkspeed_red.Top             = 186;
  l_blinkspeed_red.Width           = 10;
  l_blinkspeed_red.Height          = 15;
  l_blinkspeed_red.Visible         = 1;
  l_blinkspeed_red.Active          = 1;
  l_blinkspeed_red.Caption         = l_blinkspeed_red_Caption;
  l_blinkspeed_red.FontName        = Tahoma11x13_Regular;
  l_blinkspeed_red.Font_Color      = 0x0000;
  l_blinkspeed_red.VerticalText    = 0;
  l_blinkspeed_red.OnUpPtr         = 0;
  l_blinkspeed_red.OnDownPtr       = 0;
  l_blinkspeed_red.OnClickPtr      = 0;
  l_blinkspeed_red.OnPressPtr      = 0;

  l_blinkspeed_green.OwnerScreen     = &home;
  l_blinkspeed_green.Order           = 42;
  l_blinkspeed_green.Left            = 129;
  l_blinkspeed_green.Top             = 186;
  l_blinkspeed_green.Width           = 10;
  l_blinkspeed_green.Height          = 15;
  l_blinkspeed_green.Visible         = 1;
  l_blinkspeed_green.Active          = 1;
  l_blinkspeed_green.Caption         = l_blinkspeed_green_Caption;
  l_blinkspeed_green.FontName        = Tahoma11x13_Regular;
  l_blinkspeed_green.Font_Color      = 0x0000;
  l_blinkspeed_green.VerticalText    = 0;
  l_blinkspeed_green.OnUpPtr         = 0;
  l_blinkspeed_green.OnDownPtr       = 0;
  l_blinkspeed_green.OnClickPtr      = 0;
  l_blinkspeed_green.OnPressPtr      = 0;

  l_blinkspeed_blue.OwnerScreen     = &home;
  l_blinkspeed_blue.Order           = 43;
  l_blinkspeed_blue.Left            = 214;
  l_blinkspeed_blue.Top             = 186;
  l_blinkspeed_blue.Width           = 10;
  l_blinkspeed_blue.Height          = 15;
  l_blinkspeed_blue.Visible         = 1;
  l_blinkspeed_blue.Active          = 1;
  l_blinkspeed_blue.Caption         = l_blinkspeed_blue_Caption;
  l_blinkspeed_blue.FontName        = Tahoma11x13_Regular;
  l_blinkspeed_blue.Font_Color      = 0x0000;
  l_blinkspeed_blue.VerticalText    = 0;
  l_blinkspeed_blue.OnUpPtr         = 0;
  l_blinkspeed_blue.OnDownPtr       = 0;
  l_blinkspeed_blue.OnClickPtr      = 0;
  l_blinkspeed_blue.OnPressPtr      = 0;

  Label33.OwnerScreen     = &home;
  Label33.Order           = 44;
  Label33.Left            = 8;
  Label33.Top             = 185;
  Label33.Width           = 25;
  Label33.Height          = 15;
  Label33.Visible         = 1;
  Label33.Active          = 1;
  Label33.Caption         = Label33_Caption;
  Label33.FontName        = Tahoma11x13_Regular;
  Label33.Font_Color      = 0xF800;
  Label33.VerticalText    = 0;
  Label33.OnUpPtr         = 0;
  Label33.OnDownPtr       = 0;
  Label33.OnClickPtr      = 0;
  Label33.OnPressPtr      = 0;

  Label34.OwnerScreen     = &home;
  Label34.Order           = 45;
  Label34.Left            = 83;
  Label34.Top             = 184;
  Label34.Width           = 39;
  Label34.Height          = 15;
  Label34.Visible         = 1;
  Label34.Active          = 1;
  Label34.Caption         = Label34_Caption;
  Label34.FontName        = Tahoma11x13_Regular;
  Label34.Font_Color      = 0x07E0;
  Label34.VerticalText    = 0;
  Label34.OnUpPtr         = 0;
  Label34.OnDownPtr       = 0;
  Label34.OnClickPtr      = 0;
  Label34.OnPressPtr      = 0;

  Label35.OwnerScreen     = &home;
  Label35.Order           = 46;
  Label35.Left            = 176;
  Label35.Top             = 185;
  Label35.Width           = 30;
  Label35.Height          = 15;
  Label35.Visible         = 1;
  Label35.Active          = 1;
  Label35.Caption         = Label35_Caption;
  Label35.FontName        = Tahoma11x13_Regular;
  Label35.Font_Color      = 0x001F;
  Label35.VerticalText    = 0;
  Label35.OnUpPtr         = 0;
  Label35.OnDownPtr       = 0;
  Label35.OnClickPtr      = 0;
  Label35.OnPressPtr      = 0;

  Label36.OwnerScreen     = &home;
  Label36.Order           = 47;
  Label36.Left            = 12;
  Label36.Top             = 160;
  Label36.Width           = 80;
  Label36.Height          = 15;
  Label36.Visible         = 1;
  Label36.Active          = 1;
  Label36.Caption         = Label36_Caption;
  Label36.FontName        = Tahoma13x13_Bold;
  Label36.Font_Color      = 0x0010;
  Label36.VerticalText    = 0;
  Label36.OnUpPtr         = 0;
  Label36.OnDownPtr       = 0;
  Label36.OnClickPtr      = 0;
  Label36.OnPressPtr      = 0;

  Line3.OwnerScreen     = &home;
  Line3.Order           = 48;
  Line3.First_Point_X   = 12;
  Line3.First_Point_Y   = 177;
  Line3.Second_Point_X  = 248;
  Line3.Second_Point_Y  = 177;
  Line3.Visible         = 1;
  Line3.Pen_Width       = 2;
  Line3.Color           = 0x0010;

  Label37.OwnerScreen     = &home;
  Label37.Order           = 49;
  Label37.Left            = 100;
  Label37.Top             = 160;
  Label37.Width           = 148;
  Label37.Height          = 15;
  Label37.Visible         = 1;
  Label37.Active          = 1;
  Label37.Caption         = Label37_Caption;
  Label37.FontName        = Tahoma11x13_Regular;
  Label37.Font_Color      = 0x0010;
  Label37.VerticalText    = 0;
  Label37.OnUpPtr         = 0;
  Label37.OnDownPtr       = 0;
  Label37.OnClickPtr      = 0;
  Label37.OnPressPtr      = 0;

  Label7.OwnerScreen     = &help_screen;
  Label7.Order           = 0;
  Label7.Left            = 26;
  Label7.Top             = 62;
  Label7.Width           = 150;
  Label7.Height          = 27;
  Label7.Visible         = 1;
  Label7.Active          = 1;
  Label7.Caption         = Label7_Caption;
  Label7.FontName        = Tahoma20x24_Regular;
  Label7.Font_Color      = 0x0000;
  Label7.VerticalText    = 0;
  Label7.OnUpPtr         = 0;
  Label7.OnDownPtr       = 0;
  Label7.OnClickPtr      = 0;
  Label7.OnPressPtr      = 0;

  Label8.OwnerScreen     = &help_screen;
  Label8.Order           = 1;
  Label8.Left            = 34;
  Label8.Top             = 100;
  Label8.Width           = 16;
  Label8.Height          = 15;
  Label8.Visible         = 1;
  Label8.Active          = 1;
  Label8.Caption         = Label8_Caption;
  Label8.FontName        = Tahoma11x13_Regular;
  Label8.Font_Color      = 0x0000;
  Label8.VerticalText    = 0;
  Label8.OnUpPtr         = 0;
  Label8.OnDownPtr       = 0;
  Label8.OnClickPtr      = 0;
  Label8.OnPressPtr      = 0;

  Label9.OwnerScreen     = &help_screen;
  Label9.Order           = 2;
  Label9.Left            = 76;
  Label9.Top             = 100;
  Label9.Width           = 60;
  Label9.Height          = 15;
  Label9.Visible         = 1;
  Label9.Active          = 1;
  Label9.Caption         = Label9_Caption;
  Label9.FontName        = Tahoma11x13_Regular;
  Label9.Font_Color      = 0x0000;
  Label9.VerticalText    = 0;
  Label9.OnUpPtr         = 0;
  Label9.OnDownPtr       = 0;
  Label9.OnClickPtr      = 0;
  Label9.OnPressPtr      = 0;

  Label10.OwnerScreen     = &help_screen;
  Label10.Order           = 3;
  Label10.Left            = 153;
  Label10.Top             = 100;
  Label10.Width           = 39;
  Label10.Height          = 15;
  Label10.Visible         = 1;
  Label10.Active          = 1;
  Label10.Caption         = Label10_Caption;
  Label10.FontName        = Tahoma11x13_Regular;
  Label10.Font_Color      = 0x0000;
  Label10.VerticalText    = 0;
  Label10.OnUpPtr         = 0;
  Label10.OnDownPtr       = 0;
  Label10.OnClickPtr      = 0;
  Label10.OnPressPtr      = 0;

  Line2.OwnerScreen     = &help_screen;
  Line2.Order           = 4;
  Line2.First_Point_X   = 29;
  Line2.First_Point_Y   = 118;
  Line2.Second_Point_X  = 446;
  Line2.Second_Point_Y  = 118;
  Line2.Visible         = 1;
  Line2.Pen_Width       = 2;
  Line2.Color           = 0x0000;

  Label11.OwnerScreen     = &help_screen;
  Label11.Order           = 5;
  Label11.Left            = 32;
  Label11.Top             = 126;
  Label11.Width           = 28;
  Label11.Height          = 15;
  Label11.Visible         = 1;
  Label11.Active          = 1;
  Label11.Caption         = Label11_Caption;
  Label11.FontName        = Tahoma11x13_Regular;
  Label11.Font_Color      = 0x0000;
  Label11.VerticalText    = 0;
  Label11.OnUpPtr         = 0;
  Label11.OnDownPtr       = 0;
  Label11.OnClickPtr      = 0;
  Label11.OnPressPtr      = 0;

  Label12.OwnerScreen     = &help_screen;
  Label12.Order           = 6;
  Label12.Left            = 75;
  Label12.Top             = 126;
  Label12.Width           = 45;
  Label12.Height          = 15;
  Label12.Visible         = 1;
  Label12.Active          = 1;
  Label12.Caption         = Label12_Caption;
  Label12.FontName        = Tahoma11x13_Regular;
  Label12.Font_Color      = 0x0000;
  Label12.VerticalText    = 0;
  Label12.OnUpPtr         = 0;
  Label12.OnDownPtr       = 0;
  Label12.OnClickPtr      = 0;
  Label12.OnPressPtr      = 0;

  Label13.OwnerScreen     = &help_screen;
  Label13.Order           = 7;
  Label13.Left            = 155;
  Label13.Top             = 126;
  Label13.Width           = 85;
  Label13.Height          = 15;
  Label13.Visible         = 1;
  Label13.Active          = 1;
  Label13.Caption         = Label13_Caption;
  Label13.FontName        = Tahoma11x13_Regular;
  Label13.Font_Color      = 0x0000;
  Label13.VerticalText    = 0;
  Label13.OnUpPtr         = 0;
  Label13.OnDownPtr       = 0;
  Label13.OnClickPtr      = 0;
  Label13.OnPressPtr      = 0;

  Label14.OwnerScreen     = &help_screen;
  Label14.Order           = 8;
  Label14.Left            = 32;
  Label14.Top             = 142;
  Label14.Width           = 28;
  Label14.Height          = 15;
  Label14.Visible         = 1;
  Label14.Active          = 1;
  Label14.Caption         = Label14_Caption;
  Label14.FontName        = Tahoma11x13_Regular;
  Label14.Font_Color      = 0x0000;
  Label14.VerticalText    = 0;
  Label14.OnUpPtr         = 0;
  Label14.OnDownPtr       = 0;
  Label14.OnClickPtr      = 0;
  Label14.OnPressPtr      = 0;

  Label15.OwnerScreen     = &help_screen;
  Label15.Order           = 9;
  Label15.Left            = 75;
  Label15.Top             = 142;
  Label15.Width           = 54;
  Label15.Height          = 15;
  Label15.Visible         = 1;
  Label15.Active          = 1;
  Label15.Caption         = Label15_Caption;
  Label15.FontName        = Tahoma11x13_Regular;
  Label15.Font_Color      = 0x0000;
  Label15.VerticalText    = 0;
  Label15.OnUpPtr         = 0;
  Label15.OnDownPtr       = 0;
  Label15.OnClickPtr      = 0;
  Label15.OnPressPtr      = 0;

  Label16.OwnerScreen     = &help_screen;
  Label16.Order           = 10;
  Label16.Left            = 155;
  Label16.Top             = 142;
  Label16.Width           = 219;
  Label16.Height          = 15;
  Label16.Visible         = 1;
  Label16.Active          = 1;
  Label16.Caption         = Label16_Caption;
  Label16.FontName        = Tahoma11x13_Regular;
  Label16.Font_Color      = 0x0000;
  Label16.VerticalText    = 0;
  Label16.OnUpPtr         = 0;
  Label16.OnDownPtr       = 0;
  Label16.OnClickPtr      = 0;
  Label16.OnPressPtr      = 0;

  Label20.OwnerScreen     = &help_screen;
  Label20.Order           = 11;
  Label20.Left            = 32;
  Label20.Top             = 158;
  Label20.Width           = 28;
  Label20.Height          = 15;
  Label20.Visible         = 1;
  Label20.Active          = 1;
  Label20.Caption         = Label20_Caption;
  Label20.FontName        = Tahoma11x13_Regular;
  Label20.Font_Color      = 0x0000;
  Label20.VerticalText    = 0;
  Label20.OnUpPtr         = 0;
  Label20.OnDownPtr       = 0;
  Label20.OnClickPtr      = 0;
  Label20.OnPressPtr      = 0;

  Label21.OwnerScreen     = &help_screen;
  Label21.Order           = 12;
  Label21.Left            = 75;
  Label21.Top             = 158;
  Label21.Width           = 54;
  Label21.Height          = 15;
  Label21.Visible         = 1;
  Label21.Active          = 1;
  Label21.Caption         = Label21_Caption;
  Label21.FontName        = Tahoma11x13_Regular;
  Label21.Font_Color      = 0x0000;
  Label21.VerticalText    = 0;
  Label21.OnUpPtr         = 0;
  Label21.OnDownPtr       = 0;
  Label21.OnClickPtr      = 0;
  Label21.OnPressPtr      = 0;

  Label22.OwnerScreen     = &help_screen;
  Label22.Order           = 13;
  Label22.Left            = 155;
  Label22.Top             = 158;
  Label22.Width           = 231;
  Label22.Height          = 15;
  Label22.Visible         = 1;
  Label22.Active          = 1;
  Label22.Caption         = Label22_Caption;
  Label22.FontName        = Tahoma11x13_Regular;
  Label22.Font_Color      = 0x0000;
  Label22.VerticalText    = 0;
  Label22.OnUpPtr         = 0;
  Label22.OnDownPtr       = 0;
  Label22.OnClickPtr      = 0;
  Label22.OnPressPtr      = 0;

  Label23.OwnerScreen     = &help_screen;
  Label23.Order           = 14;
  Label23.Left            = 32;
  Label23.Top             = 173;
  Label23.Width           = 28;
  Label23.Height          = 15;
  Label23.Visible         = 1;
  Label23.Active          = 1;
  Label23.Caption         = Label23_Caption;
  Label23.FontName        = Tahoma11x13_Regular;
  Label23.Font_Color      = 0x0000;
  Label23.VerticalText    = 0;
  Label23.OnUpPtr         = 0;
  Label23.OnDownPtr       = 0;
  Label23.OnClickPtr      = 0;
  Label23.OnPressPtr      = 0;

  Label24.OwnerScreen     = &help_screen;
  Label24.Order           = 15;
  Label24.Left            = 75;
  Label24.Top             = 173;
  Label24.Width           = 54;
  Label24.Height          = 15;
  Label24.Visible         = 1;
  Label24.Active          = 1;
  Label24.Caption         = Label24_Caption;
  Label24.FontName        = Tahoma11x13_Regular;
  Label24.Font_Color      = 0x0000;
  Label24.VerticalText    = 0;
  Label24.OnUpPtr         = 0;
  Label24.OnDownPtr       = 0;
  Label24.OnClickPtr      = 0;
  Label24.OnPressPtr      = 0;

  Label25.OwnerScreen     = &help_screen;
  Label25.Order           = 16;
  Label25.Left            = 155;
  Label25.Top             = 173;
  Label25.Width           = 224;
  Label25.Height          = 15;
  Label25.Visible         = 1;
  Label25.Active          = 1;
  Label25.Caption         = Label25_Caption;
  Label25.FontName        = Tahoma11x13_Regular;
  Label25.Font_Color      = 0x0000;
  Label25.VerticalText    = 0;
  Label25.OnUpPtr         = 0;
  Label25.OnDownPtr       = 0;
  Label25.OnClickPtr      = 0;
  Label25.OnPressPtr      = 0;

  Box2.OwnerScreen     = &help_screen;
  Box2.Order           = 17;
  Box2.Left            = 0;
  Box2.Top             = 0;
  Box2.Width           = 480;
  Box2.Height          = 35;
  Box2.Pen_Width       = 1;
  Box2.Pen_Color       = 0x0000;
  Box2.Visible         = 1;
  Box2.Active          = 1;
  Box2.Transparent     = 1;
  Box2.Gradient        = 0;
  Box2.Gradient_Orientation = 0;
  Box2.Gradient_Start_Color = 0xFFFF;
  Box2.Gradient_End_Color = 0xC618;
  Box2.Color           = 0x0000;
  Box2.PressColEnabled = 0;
  Box2.Press_Color     = 0xE71C;
  Box2.OnUpPtr         = 0;
  Box2.OnDownPtr       = 0;
  Box2.OnClickPtr      = 0;
  Box2.OnPressPtr      = 0;

  help1_backbutton.OwnerScreen     = &help_screen;
  help1_backbutton.Order           = 18;
  help1_backbutton.Left            = 3;
  help1_backbutton.Top             = 3;
  help1_backbutton.Width           = 30;
  help1_backbutton.Height          = 30;
  help1_backbutton.Picture_Type    = 1;
  help1_backbutton.Picture_Ratio   = 1;
  help1_backbutton.Picture_Name    = eve_arrow_left_jpg;
  help1_backbutton.Visible         = 1;
  help1_backbutton.Active          = 1;
  help1_backbutton.OnUpPtr         = 0;
  help1_backbutton.OnDownPtr       = 0;
  help1_backbutton.OnClickPtr      = Back2Home;
  help1_backbutton.OnPressPtr      = 0;

  Label17.OwnerScreen     = &help_screen;
  Label17.Order           = 19;
  Label17.Left            = 32;
  Label17.Top             = 214;
  Label17.Width           = 35;
  Label17.Height          = 15;
  Label17.Visible         = 1;
  Label17.Active          = 1;
  Label17.Caption         = Label17_Caption;
  Label17.FontName        = Tahoma11x13_UnderLine;
  Label17.Font_Color      = 0x0000;
  Label17.VerticalText    = 0;
  Label17.OnUpPtr         = 0;
  Label17.OnDownPtr       = 0;
  Label17.OnClickPtr      = 0;
  Label17.OnPressPtr      = 0;

  Label18.OwnerScreen     = &help_screen;
  Label18.Order           = 20;
  Label18.Left            = 32;
  Label18.Top             = 230;
  Label18.Width           = 92;
  Label18.Height          = 12;
  Label18.Visible         = 1;
  Label18.Active          = 1;
  Label18.Caption         = Label18_Caption;
  Label18.FontName        = Tahoma10x11_Regular;
  Label18.Font_Color      = 0x0000;
  Label18.VerticalText    = 0;
  Label18.OnUpPtr         = 0;
  Label18.OnDownPtr       = 0;
  Label18.OnClickPtr      = 0;
  Label18.OnPressPtr      = 0;

  Label19.OwnerScreen     = &help_screen;
  Label19.Order           = 21;
  Label19.Left            = 32;
  Label19.Top             = 242;
  Label19.Width           = 125;
  Label19.Height          = 12;
  Label19.Visible         = 1;
  Label19.Active          = 1;
  Label19.Caption         = Label19_Caption;
  Label19.FontName        = Tahoma10x11_Regular;
  Label19.Font_Color      = 0x0000;
  Label19.VerticalText    = 0;
  Label19.OnUpPtr         = 0;
  Label19.OnDownPtr       = 0;
  Label19.OnClickPtr      = 0;
  Label19.OnPressPtr      = 0;

  Label26.OwnerScreen     = &help_screen;
  Label26.Order           = 22;
  Label26.Left            = 217;
  Label26.Top             = 10;
  Label26.Width           = 83;
  Label26.Height          = 20;
  Label26.Visible         = 1;
  Label26.Active          = 1;
  Label26.Caption         = Label26_Caption;
  Label26.FontName        = Tahoma18x18_Bold;
  Label26.Font_Color      = 0xFFF9;
  Label26.VerticalText    = 0;
  Label26.OnUpPtr         = 0;
  Label26.OnDownPtr       = 0;
  Label26.OnClickPtr      = 0;
  Label26.OnPressPtr      = 0;

  Label1.OwnerScreen     = &help_screen;
  Label1.Order           = 23;
  Label1.Left            = 32;
  Label1.Top             = 189;
  Label1.Width           = 29;
  Label1.Height          = 15;
  Label1.Visible         = 1;
  Label1.Active          = 1;
  Label1.Caption         = Label1_Caption;
  Label1.FontName        = Tahoma11x13_Regular;
  Label1.Font_Color      = 0x0000;
  Label1.VerticalText    = 0;
  Label1.OnUpPtr         = 0;
  Label1.OnDownPtr       = 0;
  Label1.OnClickPtr      = 0;
  Label1.OnPressPtr      = 0;

  Label2.OwnerScreen     = &help_screen;
  Label2.Order           = 24;
  Label2.Left            = 75;
  Label2.Top             = 189;
  Label2.Width           = 56;
  Label2.Height          = 15;
  Label2.Visible         = 1;
  Label2.Active          = 1;
  Label2.Caption         = Label2_Caption;
  Label2.FontName        = Tahoma11x13_Regular;
  Label2.Font_Color      = 0x0000;
  Label2.VerticalText    = 0;
  Label2.OnUpPtr         = 0;
  Label2.OnDownPtr       = 0;
  Label2.OnClickPtr      = 0;
  Label2.OnPressPtr      = 0;

  Label3.OwnerScreen     = &help_screen;
  Label3.Order           = 25;
  Label3.Left            = 155;
  Label3.Top             = 189;
  Label3.Width           = 201;
  Label3.Height          = 15;
  Label3.Visible         = 1;
  Label3.Active          = 1;
  Label3.Caption         = Label3_Caption;
  Label3.FontName        = Tahoma11x13_Regular;
  Label3.Font_Color      = 0x0000;
  Label3.VerticalText    = 0;
  Label3.OnUpPtr         = 0;
  Label3.OnDownPtr       = 0;
  Label3.OnClickPtr      = 0;
  Label3.OnPressPtr      = 0;

  Label4.OwnerScreen     = &help_screen;
  Label4.Order           = 26;
  Label4.Left            = 397;
  Label4.Top             = 100;
  Label4.Width           = 33;
  Label4.Height          = 15;
  Label4.Visible         = 1;
  Label4.Active          = 1;
  Label4.Caption         = Label4_Caption;
  Label4.FontName        = Tahoma11x13_Regular;
  Label4.Font_Color      = 0x0000;
  Label4.VerticalText    = 0;
  Label4.OnUpPtr         = 0;
  Label4.OnDownPtr       = 0;
  Label4.OnClickPtr      = 0;
  Label4.OnPressPtr      = 0;

  Label27.OwnerScreen     = &help_screen;
  Label27.Order           = 27;
  Label27.Left            = 398;
  Label27.Top             = 125;
  Label27.Width           = 16;
  Label27.Height          = 15;
  Label27.Visible         = 1;
  Label27.Active          = 1;
  Label27.Caption         = Label27_Caption;
  Label27.FontName        = Tahoma11x13_Regular;
  Label27.Font_Color      = 0x0000;
  Label27.VerticalText    = 0;
  Label27.OnUpPtr         = 0;
  Label27.OnDownPtr       = 0;
  Label27.OnClickPtr      = 0;
  Label27.OnPressPtr      = 0;

  Label28.OwnerScreen     = &help_screen;
  Label28.Order           = 28;
  Label28.Left            = 398;
  Label28.Top             = 141;
  Label28.Width           = 16;
  Label28.Height          = 15;
  Label28.Visible         = 1;
  Label28.Active          = 1;
  Label28.Caption         = Label28_Caption;
  Label28.FontName        = Tahoma11x13_Regular;
  Label28.Font_Color      = 0x0000;
  Label28.VerticalText    = 0;
  Label28.OnUpPtr         = 0;
  Label28.OnDownPtr       = 0;
  Label28.OnClickPtr      = 0;
  Label28.OnPressPtr      = 0;

  Label29.OwnerScreen     = &help_screen;
  Label29.Order           = 29;
  Label29.Left            = 398;
  Label29.Top             = 157;
  Label29.Width           = 16;
  Label29.Height          = 15;
  Label29.Visible         = 1;
  Label29.Active          = 1;
  Label29.Caption         = Label29_Caption;
  Label29.FontName        = Tahoma11x13_Regular;
  Label29.Font_Color      = 0x0000;
  Label29.VerticalText    = 0;
  Label29.OnUpPtr         = 0;
  Label29.OnDownPtr       = 0;
  Label29.OnClickPtr      = 0;
  Label29.OnPressPtr      = 0;

  Label30.OwnerScreen     = &help_screen;
  Label30.Order           = 30;
  Label30.Left            = 398;
  Label30.Top             = 173;
  Label30.Width           = 16;
  Label30.Height          = 15;
  Label30.Visible         = 1;
  Label30.Active          = 1;
  Label30.Caption         = Label30_Caption;
  Label30.FontName        = Tahoma11x13_Regular;
  Label30.Font_Color      = 0x0000;
  Label30.VerticalText    = 0;
  Label30.OnUpPtr         = 0;
  Label30.OnDownPtr       = 0;
  Label30.OnClickPtr      = 0;
  Label30.OnPressPtr      = 0;

  Label31.OwnerScreen     = &help_screen;
  Label31.Order           = 31;
  Label31.Left            = 398;
  Label31.Top             = 189;
  Label31.Width           = 16;
  Label31.Height          = 15;
  Label31.Visible         = 1;
  Label31.Active          = 1;
  Label31.Caption         = Label31_Caption;
  Label31.FontName        = Tahoma11x13_Regular;
  Label31.Font_Color      = 0x0000;
  Label31.VerticalText    = 0;
  Label31.OnUpPtr         = 0;
  Label31.OnDownPtr       = 0;
  Label31.OnClickPtr      = 0;
  Label31.OnPressPtr      = 0;

  Label32.OwnerScreen     = &help_screen;
  Label32.Order           = 32;
  Label32.Left            = 32;
  Label32.Top             = 254;
  Label32.Width           = 255;
  Label32.Height          = 12;
  Label32.Visible         = 1;
  Label32.Active          = 1;
  Label32.Caption         = Label32_Caption;
  Label32.FontName        = Tahoma10x11_Regular;
  Label32.Font_Color      = 0x0000;
  Label32.VerticalText    = 0;
  Label32.OnUpPtr         = 0;
  Label32.OnDownPtr       = 0;
  Label32.OnClickPtr      = 0;
  Label32.OnPressPtr      = 0;

  Button_7.OwnerScreen     = &ValueInputScreen;
  Button_7.Order           = 0;
  Button_7.Left            = 13;
  Button_7.Top             = 159;
  Button_7.Width           = 50;
  Button_7.Height          = 50;
  Button_7.Pen_Width       = 1;
  Button_7.Pen_Color       = 0x0000;
  Button_7.Visible         = 1;
  Button_7.Active          = 1;
  Button_7.Transparent     = 1;
  Button_7.Caption         = Button_7_Caption;
  Button_7.TextAlign       = _taCenter;
  Button_7.TextAlignVertical= _tavMiddle;
  Button_7.FontName        = Arial13x16_Bold;
  Button_7.PressColEnabled = 1;
  Button_7.Font_Color      = 0xFFFF;
  Button_7.VerticalText    = 0;
  Button_7.Gradient        = 1;
  Button_7.Gradient_Orientation = 0;
  Button_7.Gradient_Start_Color = 0x9492;
  Button_7.Gradient_End_Color = 0x0000;
  Button_7.Color           = 0xC618;
  Button_7.Press_Color     = 0xC618;
  Button_7.OnUpPtr         = 0;
  Button_7.OnDownPtr       = 0;
  Button_7.OnClickPtr      = ValueInputScreen_7;
  Button_7.OnPressPtr      = 0;

  Button_4.OwnerScreen     = &ValueInputScreen;
  Button_4.Order           = 1;
  Button_4.Left            = 13;
  Button_4.Top             = 108;
  Button_4.Width           = 50;
  Button_4.Height          = 50;
  Button_4.Pen_Width       = 1;
  Button_4.Pen_Color       = 0x0000;
  Button_4.Visible         = 1;
  Button_4.Active          = 1;
  Button_4.Transparent     = 1;
  Button_4.Caption         = Button_4_Caption;
  Button_4.TextAlign       = _taCenter;
  Button_4.TextAlignVertical= _tavMiddle;
  Button_4.FontName        = Arial13x16_Bold;
  Button_4.PressColEnabled = 1;
  Button_4.Font_Color      = 0xFFFF;
  Button_4.VerticalText    = 0;
  Button_4.Gradient        = 1;
  Button_4.Gradient_Orientation = 0;
  Button_4.Gradient_Start_Color = 0x9492;
  Button_4.Gradient_End_Color = 0x0000;
  Button_4.Color           = 0xC618;
  Button_4.Press_Color     = 0xC618;
  Button_4.OnUpPtr         = 0;
  Button_4.OnDownPtr       = 0;
  Button_4.OnClickPtr      = ValueInputScreen_4;
  Button_4.OnPressPtr      = 0;

  Button_1.OwnerScreen     = &ValueInputScreen;
  Button_1.Order           = 2;
  Button_1.Left            = 13;
  Button_1.Top             = 57;
  Button_1.Width           = 50;
  Button_1.Height          = 50;
  Button_1.Pen_Width       = 1;
  Button_1.Pen_Color       = 0x0000;
  Button_1.Visible         = 1;
  Button_1.Active          = 1;
  Button_1.Transparent     = 1;
  Button_1.Caption         = Button_1_Caption;
  Button_1.TextAlign       = _taCenter;
  Button_1.TextAlignVertical= _tavMiddle;
  Button_1.FontName        = Arial13x16_Bold;
  Button_1.PressColEnabled = 1;
  Button_1.Font_Color      = 0xFFFF;
  Button_1.VerticalText    = 0;
  Button_1.Gradient        = 1;
  Button_1.Gradient_Orientation = 0;
  Button_1.Gradient_Start_Color = 0x9492;
  Button_1.Gradient_End_Color = 0x0000;
  Button_1.Color           = 0xC618;
  Button_1.Press_Color     = 0xC618;
  Button_1.OnUpPtr         = 0;
  Button_1.OnDownPtr       = 0;
  Button_1.OnClickPtr      = ValueInputScreen_1;
  Button_1.OnPressPtr      = 0;

  Button_0.OwnerScreen     = &ValueInputScreen;
  Button_0.Order           = 3;
  Button_0.Left            = 64;
  Button_0.Top             = 210;
  Button_0.Width           = 50;
  Button_0.Height          = 50;
  Button_0.Pen_Width       = 1;
  Button_0.Pen_Color       = 0x0000;
  Button_0.Visible         = 1;
  Button_0.Active          = 1;
  Button_0.Transparent     = 1;
  Button_0.Caption         = Button_0_Caption;
  Button_0.TextAlign       = _taCenter;
  Button_0.TextAlignVertical= _tavMiddle;
  Button_0.FontName        = Arial13x16_Bold;
  Button_0.PressColEnabled = 1;
  Button_0.Font_Color      = 0xFFFF;
  Button_0.VerticalText    = 0;
  Button_0.Gradient        = 1;
  Button_0.Gradient_Orientation = 0;
  Button_0.Gradient_Start_Color = 0x9492;
  Button_0.Gradient_End_Color = 0x0000;
  Button_0.Color           = 0xC618;
  Button_0.Press_Color     = 0xC618;
  Button_0.OnUpPtr         = 0;
  Button_0.OnDownPtr       = 0;
  Button_0.OnClickPtr      = ValueInputScreen_0;
  Button_0.OnPressPtr      = 0;

  Button_8.OwnerScreen     = &ValueInputScreen;
  Button_8.Order           = 4;
  Button_8.Left            = 64;
  Button_8.Top             = 159;
  Button_8.Width           = 50;
  Button_8.Height          = 50;
  Button_8.Pen_Width       = 1;
  Button_8.Pen_Color       = 0x0000;
  Button_8.Visible         = 1;
  Button_8.Active          = 1;
  Button_8.Transparent     = 1;
  Button_8.Caption         = Button_8_Caption;
  Button_8.TextAlign       = _taCenter;
  Button_8.TextAlignVertical= _tavMiddle;
  Button_8.FontName        = Arial13x16_Bold;
  Button_8.PressColEnabled = 1;
  Button_8.Font_Color      = 0xFFFF;
  Button_8.VerticalText    = 0;
  Button_8.Gradient        = 1;
  Button_8.Gradient_Orientation = 0;
  Button_8.Gradient_Start_Color = 0x9492;
  Button_8.Gradient_End_Color = 0x0000;
  Button_8.Color           = 0xC618;
  Button_8.Press_Color     = 0xC618;
  Button_8.OnUpPtr         = 0;
  Button_8.OnDownPtr       = 0;
  Button_8.OnClickPtr      = ValueInputScreen_8;
  Button_8.OnPressPtr      = 0;

  Button_5.OwnerScreen     = &ValueInputScreen;
  Button_5.Order           = 5;
  Button_5.Left            = 64;
  Button_5.Top             = 108;
  Button_5.Width           = 50;
  Button_5.Height          = 50;
  Button_5.Pen_Width       = 1;
  Button_5.Pen_Color       = 0x0000;
  Button_5.Visible         = 1;
  Button_5.Active          = 1;
  Button_5.Transparent     = 1;
  Button_5.Caption         = Button_5_Caption;
  Button_5.TextAlign       = _taCenter;
  Button_5.TextAlignVertical= _tavMiddle;
  Button_5.FontName        = Arial13x16_Bold;
  Button_5.PressColEnabled = 1;
  Button_5.Font_Color      = 0xFFFF;
  Button_5.VerticalText    = 0;
  Button_5.Gradient        = 1;
  Button_5.Gradient_Orientation = 0;
  Button_5.Gradient_Start_Color = 0x9492;
  Button_5.Gradient_End_Color = 0x0000;
  Button_5.Color           = 0xC618;
  Button_5.Press_Color     = 0xC618;
  Button_5.OnUpPtr         = 0;
  Button_5.OnDownPtr       = 0;
  Button_5.OnClickPtr      = ValueInputScreen_5;
  Button_5.OnPressPtr      = 0;

  Button_2.OwnerScreen     = &ValueInputScreen;
  Button_2.Order           = 6;
  Button_2.Left            = 64;
  Button_2.Top             = 57;
  Button_2.Width           = 50;
  Button_2.Height          = 50;
  Button_2.Pen_Width       = 1;
  Button_2.Pen_Color       = 0x0000;
  Button_2.Visible         = 1;
  Button_2.Active          = 1;
  Button_2.Transparent     = 1;
  Button_2.Caption         = Button_2_Caption;
  Button_2.TextAlign       = _taCenter;
  Button_2.TextAlignVertical= _tavMiddle;
  Button_2.FontName        = Arial13x16_Bold;
  Button_2.PressColEnabled = 1;
  Button_2.Font_Color      = 0xFFFF;
  Button_2.VerticalText    = 0;
  Button_2.Gradient        = 1;
  Button_2.Gradient_Orientation = 0;
  Button_2.Gradient_Start_Color = 0x9492;
  Button_2.Gradient_End_Color = 0x0000;
  Button_2.Color           = 0xC618;
  Button_2.Press_Color     = 0xC618;
  Button_2.OnUpPtr         = 0;
  Button_2.OnDownPtr       = 0;
  Button_2.OnClickPtr      = ValueInputScreen_2;
  Button_2.OnPressPtr      = 0;

  top_bar.OwnerScreen     = &ValueInputScreen;
  top_bar.Order           = 7;
  top_bar.Left            = 0;
  top_bar.Top             = 1;
  top_bar.Width           = 480;
  top_bar.Height          = 30;
  top_bar.Pen_Width       = 1;
  top_bar.Pen_Color       = 0x0000;
  top_bar.Visible         = 1;
  top_bar.Active          = 1;
  top_bar.Transparent     = 1;
  top_bar.Gradient        = 1;
  top_bar.Gradient_Orientation = 0;
  top_bar.Gradient_Start_Color = 0x9492;
  top_bar.Gradient_End_Color = 0x0000;
  top_bar.Color           = 0xC618;
  top_bar.PressColEnabled = 0;
  top_bar.Press_Color     = 0x8410;
  top_bar.OnUpPtr         = 0;
  top_bar.OnDownPtr       = 0;
  top_bar.OnClickPtr      = 0;
  top_bar.OnPressPtr      = 0;

  Button_close.OwnerScreen     = &ValueInputScreen;
  Button_close.Order           = 8;
  Button_close.Left            = 452;
  Button_close.Top             = 1;
  Button_close.Width           = 27;
  Button_close.Height          = 27;
  Button_close.Pen_Width       = 1;
  Button_close.Pen_Color       = 0x0000;
  Button_close.Visible         = 1;
  Button_close.Active          = 1;
  Button_close.Transparent     = 1;
  Button_close.Caption         = Button_close_Caption;
  Button_close.TextAlign       = _taCenter;
  Button_close.TextAlignVertical= _tavMiddle;
  Button_close.FontName        = Tahoma19x23_Regular;
  Button_close.PressColEnabled = 1;
  Button_close.Font_Color      = 0x0000;
  Button_close.VerticalText    = 0;
  Button_close.Gradient        = 1;
  Button_close.Gradient_Orientation = 0;
  Button_close.Gradient_Start_Color = 0xF800;
  Button_close.Gradient_End_Color = 0xFA08;
  Button_close.Color           = 0xC618;
  Button_close.Press_Color     = 0x8410;
  Button_close.Corner_Radius   = 3;
  Button_close.OnUpPtr         = 0;
  Button_close.OnDownPtr       = 0;
  Button_close.OnClickPtr      = ValueInputScreen_Close;
  Button_close.OnPressPtr      = 0;

  Button_plusminus.OwnerScreen     = &ValueInputScreen;
  Button_plusminus.Order           = 9;
  Button_plusminus.Left            = 13;
  Button_plusminus.Top             = 210;
  Button_plusminus.Width           = 50;
  Button_plusminus.Height          = 50;
  Button_plusminus.Pen_Width       = 1;
  Button_plusminus.Pen_Color       = 0x0000;
  Button_plusminus.Visible         = 1;
  Button_plusminus.Active          = 1;
  Button_plusminus.Transparent     = 1;
  Button_plusminus.Caption         = Button_plusminus_Caption;
  Button_plusminus.TextAlign       = _taCenter;
  Button_plusminus.TextAlignVertical= _tavMiddle;
  Button_plusminus.FontName        = Arial13x16_Bold;
  Button_plusminus.PressColEnabled = 1;
  Button_plusminus.Font_Color      = 0xFFFF;
  Button_plusminus.VerticalText    = 0;
  Button_plusminus.Gradient        = 1;
  Button_plusminus.Gradient_Orientation = 0;
  Button_plusminus.Gradient_Start_Color = 0x9492;
  Button_plusminus.Gradient_End_Color = 0x0000;
  Button_plusminus.Color           = 0xC618;
  Button_plusminus.Press_Color     = 0xC618;
  Button_plusminus.OnUpPtr         = 0;
  Button_plusminus.OnDownPtr       = 0;
  Button_plusminus.OnClickPtr      = ValueInputScreen_plusminus;
  Button_plusminus.OnPressPtr      = 0;

  Button_9.OwnerScreen     = &ValueInputScreen;
  Button_9.Order           = 10;
  Button_9.Left            = 115;
  Button_9.Top             = 159;
  Button_9.Width           = 50;
  Button_9.Height          = 50;
  Button_9.Pen_Width       = 1;
  Button_9.Pen_Color       = 0x0000;
  Button_9.Visible         = 1;
  Button_9.Active          = 1;
  Button_9.Transparent     = 1;
  Button_9.Caption         = Button_9_Caption;
  Button_9.TextAlign       = _taCenter;
  Button_9.TextAlignVertical= _tavMiddle;
  Button_9.FontName        = Arial13x16_Bold;
  Button_9.PressColEnabled = 1;
  Button_9.Font_Color      = 0xFFFF;
  Button_9.VerticalText    = 0;
  Button_9.Gradient        = 1;
  Button_9.Gradient_Orientation = 0;
  Button_9.Gradient_Start_Color = 0x9492;
  Button_9.Gradient_End_Color = 0x0000;
  Button_9.Color           = 0xC618;
  Button_9.Press_Color     = 0xC618;
  Button_9.OnUpPtr         = 0;
  Button_9.OnDownPtr       = 0;
  Button_9.OnClickPtr      = ValueInputScreen_9;
  Button_9.OnPressPtr      = 0;

  Button_clear.OwnerScreen     = &ValueInputScreen;
  Button_clear.Order           = 11;
  Button_clear.Left            = 354;
  Button_clear.Top             = 208;
  Button_clear.Width           = 72;
  Button_clear.Height          = 72;
  Button_clear.Picture_Type    = 0;
  Button_clear.Picture_Ratio   = 1;
  Button_clear.Picture_Name    = clear_bmp;
  Button_clear.Visible         = 1;
  Button_clear.Active          = 1;
  Button_clear.OnUpPtr         = 0;
  Button_clear.OnDownPtr       = 0;
  Button_clear.OnClickPtr      = ValueInputScreen_Clear;
  Button_clear.OnPressPtr      = 0;

  BoxRound1.OwnerScreen     = &ValueInputScreen;
  BoxRound1.Order           = 12;
  BoxRound1.Left            = 1;
  BoxRound1.Top             = 56;
  BoxRound1.Width           = 10;
  BoxRound1.Height          = 204;
  BoxRound1.Pen_Width       = 1;
  BoxRound1.Pen_Color       = 0x0000;
  BoxRound1.Visible         = 1;
  BoxRound1.Active          = 1;
  BoxRound1.Transparent     = 1;
  BoxRound1.Gradient        = 1;
  BoxRound1.Gradient_Orientation = 0;
  BoxRound1.Gradient_Start_Color = 0x9492;
  BoxRound1.Gradient_End_Color = 0x0000;
  BoxRound1.Color           = 0xC618;
  BoxRound1.PressColEnabled = 1;
  BoxRound1.Press_Color     = 0xE71C;
  BoxRound1.Corner_Radius   = 3;
  BoxRound1.OnUpPtr         = 0;
  BoxRound1.OnDownPtr       = 0;
  BoxRound1.OnClickPtr      = 0;
  BoxRound1.OnPressPtr      = 0;

  BoxRound3.OwnerScreen     = &ValueInputScreen;
  BoxRound3.Order           = 13;
  BoxRound3.Left            = 488;
  BoxRound3.Top             = 79;
  BoxRound3.Width           = 10;
  BoxRound3.Height          = 204;
  BoxRound3.Pen_Width       = 1;
  BoxRound3.Pen_Color       = 0x0000;
  BoxRound3.Visible         = 1;
  BoxRound3.Active          = 1;
  BoxRound3.Transparent     = 1;
  BoxRound3.Gradient        = 1;
  BoxRound3.Gradient_Orientation = 0;
  BoxRound3.Gradient_Start_Color = 0x9492;
  BoxRound3.Gradient_End_Color = 0x0000;
  BoxRound3.Color           = 0xC618;
  BoxRound3.PressColEnabled = 1;
  BoxRound3.Press_Color     = 0xE71C;
  BoxRound3.Corner_Radius   = 3;
  BoxRound3.OnUpPtr         = 0;
  BoxRound3.OnDownPtr       = 0;
  BoxRound3.OnClickPtr      = 0;
  BoxRound3.OnPressPtr      = 0;

  Button_accept.OwnerScreen     = &ValueInputScreen;
  Button_accept.Order           = 14;
  Button_accept.Left            = 431;
  Button_accept.Top             = 222;
  Button_accept.Width           = 48;
  Button_accept.Height          = 48;
  Button_accept.Picture_Type    = 0;
  Button_accept.Picture_Ratio   = 1;
  Button_accept.Picture_Name    = okbutton_48_48pxl_bmp;
  Button_accept.Visible         = 1;
  Button_accept.Active          = 1;
  Button_accept.OnUpPtr         = 0;
  Button_accept.OnDownPtr       = 0;
  Button_accept.OnClickPtr      = ValueInputScreen_Accept;
  Button_accept.OnPressPtr      = 0;

  BoxRound6.OwnerScreen     = &ValueInputScreen;
  BoxRound6.Order           = 15;
  BoxRound6.Left            = 107;
  BoxRound6.Top             = 378;
  BoxRound6.Width           = 50;
  BoxRound6.Height          = 25;
  BoxRound6.Pen_Width       = 1;
  BoxRound6.Pen_Color       = 0x0000;
  BoxRound6.Visible         = 1;
  BoxRound6.Active          = 1;
  BoxRound6.Transparent     = 1;
  BoxRound6.Gradient        = 1;
  BoxRound6.Gradient_Orientation = 0;
  BoxRound6.Gradient_Start_Color = 0xFFFF;
  BoxRound6.Gradient_End_Color = 0xC618;
  BoxRound6.Color           = 0xC618;
  BoxRound6.PressColEnabled = 1;
  BoxRound6.Press_Color     = 0xE71C;
  BoxRound6.Corner_Radius   = 3;
  BoxRound6.OnUpPtr         = 0;
  BoxRound6.OnDownPtr       = 0;
  BoxRound6.OnClickPtr      = 0;
  BoxRound6.OnPressPtr      = 0;

  Button_backspace.OwnerScreen     = &ValueInputScreen;
  Button_backspace.Order           = 16;
  Button_backspace.Left            = 164;
  Button_backspace.Top             = 57;
  Button_backspace.Width           = 48;
  Button_backspace.Height          = 48;
  Button_backspace.Picture_Type    = 0;
  Button_backspace.Picture_Ratio   = 1;
  Button_backspace.Picture_Name    = backspace_bmp;
  Button_backspace.Visible         = 1;
  Button_backspace.Active          = 1;
  Button_backspace.OnUpPtr         = 0;
  Button_backspace.OnDownPtr       = 0;
  Button_backspace.OnClickPtr      = ValueInputScreen_BackSpace;
  Button_backspace.OnPressPtr      = 0;

  Button_dot.OwnerScreen     = &ValueInputScreen;
  Button_dot.Order           = 17;
  Button_dot.Left            = 115;
  Button_dot.Top             = 210;
  Button_dot.Width           = 50;
  Button_dot.Height          = 50;
  Button_dot.Pen_Width       = 1;
  Button_dot.Pen_Color       = 0x0000;
  Button_dot.Visible         = 1;
  Button_dot.Active          = 1;
  Button_dot.Transparent     = 1;
  Button_dot.Caption         = Button_dot_Caption;
  Button_dot.TextAlign       = _taCenter;
  Button_dot.TextAlignVertical= _tavMiddle;
  Button_dot.FontName        = Arial13x16_Bold;
  Button_dot.PressColEnabled = 1;
  Button_dot.Font_Color      = 0xFFFF;
  Button_dot.VerticalText    = 0;
  Button_dot.Gradient        = 1;
  Button_dot.Gradient_Orientation = 0;
  Button_dot.Gradient_Start_Color = 0x9492;
  Button_dot.Gradient_End_Color = 0x0000;
  Button_dot.Color           = 0xC618;
  Button_dot.Press_Color     = 0xC618;
  Button_dot.OnUpPtr         = 0;
  Button_dot.OnDownPtr       = 0;
  Button_dot.OnClickPtr      = ValueInputScreen_dot;
  Button_dot.OnPressPtr      = 0;

  Button_6.OwnerScreen     = &ValueInputScreen;
  Button_6.Order           = 18;
  Button_6.Left            = 115;
  Button_6.Top             = 108;
  Button_6.Width           = 50;
  Button_6.Height          = 50;
  Button_6.Pen_Width       = 1;
  Button_6.Pen_Color       = 0x0000;
  Button_6.Visible         = 1;
  Button_6.Active          = 1;
  Button_6.Transparent     = 1;
  Button_6.Caption         = Button_6_Caption;
  Button_6.TextAlign       = _taCenter;
  Button_6.TextAlignVertical= _tavMiddle;
  Button_6.FontName        = Arial13x16_Bold;
  Button_6.PressColEnabled = 1;
  Button_6.Font_Color      = 0xFFFF;
  Button_6.VerticalText    = 0;
  Button_6.Gradient        = 1;
  Button_6.Gradient_Orientation = 0;
  Button_6.Gradient_Start_Color = 0x9492;
  Button_6.Gradient_End_Color = 0x0000;
  Button_6.Color           = 0xC618;
  Button_6.Press_Color     = 0xC618;
  Button_6.OnUpPtr         = 0;
  Button_6.OnDownPtr       = 0;
  Button_6.OnClickPtr      = ValueInputScreen_6;
  Button_6.OnPressPtr      = 0;

  Button_3.OwnerScreen     = &ValueInputScreen;
  Button_3.Order           = 19;
  Button_3.Left            = 115;
  Button_3.Top             = 57;
  Button_3.Width           = 50;
  Button_3.Height          = 50;
  Button_3.Pen_Width       = 1;
  Button_3.Pen_Color       = 0x0000;
  Button_3.Visible         = 1;
  Button_3.Active          = 1;
  Button_3.Transparent     = 1;
  Button_3.Caption         = Button_3_Caption;
  Button_3.TextAlign       = _taCenter;
  Button_3.TextAlignVertical= _tavMiddle;
  Button_3.FontName        = Arial13x16_Bold;
  Button_3.PressColEnabled = 1;
  Button_3.Font_Color      = 0xFFFF;
  Button_3.VerticalText    = 0;
  Button_3.Gradient        = 1;
  Button_3.Gradient_Orientation = 0;
  Button_3.Gradient_Start_Color = 0x9492;
  Button_3.Gradient_End_Color = 0x0000;
  Button_3.Color           = 0xC618;
  Button_3.Press_Color     = 0xC618;
  Button_3.OnUpPtr         = 0;
  Button_3.OnDownPtr       = 0;
  Button_3.OnClickPtr      = ValueInputScreen_3;
  Button_3.OnPressPtr      = 0;

  BoxRound2.OwnerScreen     = &ValueInputScreen;
  BoxRound2.Order           = 20;
  BoxRound2.Left            = 210;
  BoxRound2.Top             = 56;
  BoxRound2.Width           = 10;
  BoxRound2.Height          = 204;
  BoxRound2.Pen_Width       = 1;
  BoxRound2.Pen_Color       = 0x0000;
  BoxRound2.Visible         = 1;
  BoxRound2.Active          = 1;
  BoxRound2.Transparent     = 1;
  BoxRound2.Gradient        = 1;
  BoxRound2.Gradient_Orientation = 0;
  BoxRound2.Gradient_Start_Color = 0x9492;
  BoxRound2.Gradient_End_Color = 0x0000;
  BoxRound2.Color           = 0xC618;
  BoxRound2.PressColEnabled = 1;
  BoxRound2.Press_Color     = 0xE71C;
  BoxRound2.Corner_Radius   = 3;
  BoxRound2.OnUpPtr         = 0;
  BoxRound2.OnDownPtr       = 0;
  BoxRound2.OnClickPtr      = 0;
  BoxRound2.OnPressPtr      = 0;

  BoxRound4.OwnerScreen     = &ValueInputScreen;
  BoxRound4.Order           = 21;
  BoxRound4.Left            = 167;
  BoxRound4.Top             = 107;
  BoxRound4.Width           = 42;
  BoxRound4.Height          = 156;
  BoxRound4.Pen_Width       = 1;
  BoxRound4.Pen_Color       = 0x0000;
  BoxRound4.Visible         = 1;
  BoxRound4.Active          = 1;
  BoxRound4.Transparent     = 1;
  BoxRound4.Gradient        = 1;
  BoxRound4.Gradient_Orientation = 0;
  BoxRound4.Gradient_Start_Color = 0x9492;
  BoxRound4.Gradient_End_Color = 0x0000;
  BoxRound4.Color           = 0xC618;
  BoxRound4.PressColEnabled = 1;
  BoxRound4.Press_Color     = 0xE71C;
  BoxRound4.Corner_Radius   = 3;
  BoxRound4.OnUpPtr         = 0;
  BoxRound4.OnDownPtr       = 0;
  BoxRound4.OnClickPtr      = 0;
  BoxRound4.OnPressPtr      = 0;

  BoxRound7.OwnerScreen     = &ValueInputScreen;
  BoxRound7.Order           = 22;
  BoxRound7.Left            = 221;
  BoxRound7.Top             = 56;
  BoxRound7.Width           = 256;
  BoxRound7.Height          = 167;
  BoxRound7.Pen_Width       = 0;
  BoxRound7.Pen_Color       = 0x0000;
  BoxRound7.Visible         = 1;
  BoxRound7.Active          = 1;
  BoxRound7.Transparent     = 1;
  BoxRound7.Gradient        = 1;
  BoxRound7.Gradient_Orientation = 0;
  BoxRound7.Gradient_Start_Color = 0x9492;
  BoxRound7.Gradient_End_Color = 0x0000;
  BoxRound7.Color           = 0xC618;
  BoxRound7.PressColEnabled = 1;
  BoxRound7.Press_Color     = 0xE71C;
  BoxRound7.Corner_Radius   = 3;
  BoxRound7.OnUpPtr         = 0;
  BoxRound7.OnDownPtr       = 0;
  BoxRound7.OnClickPtr      = 0;
  BoxRound7.OnPressPtr      = 0;

  Box_display.OwnerScreen     = &ValueInputScreen;
  Box_display.Order           = 23;
  Box_display.Left            = 1;
  Box_display.Top             = 29;
  Box_display.Width           = 477;
  Box_display.Height          = 26;
  Box_display.Pen_Width       = 1;
  Box_display.Pen_Color       = 0x0000;
  Box_display.Visible         = 1;
  Box_display.Active          = 1;
  Box_display.Transparent     = 1;
  Box_display.Gradient        = 0;
  Box_display.Gradient_Orientation = 0;
  Box_display.Gradient_Start_Color = 0xFFFF;
  Box_display.Gradient_End_Color = 0xC618;
  Box_display.Color           = 0x07E6;
  Box_display.PressColEnabled = 1;
  Box_display.Press_Color     = 0xE71C;
  Box_display.Corner_Radius   = 3;
  Box_display.OnUpPtr         = 0;
  Box_display.OnDownPtr       = 0;
  Box_display.OnClickPtr      = 0;
  Box_display.OnPressPtr      = 0;

  l_input_value_text.OwnerScreen     = &ValueInputScreen;
  l_input_value_text.Order           = 24;
  l_input_value_text.Left            = 250;
  l_input_value_text.Top             = 74;
  l_input_value_text.Width           = 198;
  l_input_value_text.Height          = 20;
  l_input_value_text.Visible         = 1;
  l_input_value_text.Active          = 1;
  l_input_value_text.Caption         = l_input_value_text_Caption;
  l_input_value_text.FontName        = Arial_Narrow13x20_Bold;
  l_input_value_text.Font_Color      = 0xFFFF;
  l_input_value_text.VerticalText    = 0;
  l_input_value_text.OnUpPtr         = 0;
  l_input_value_text.OnDownPtr       = 0;
  l_input_value_text.OnClickPtr      = 0;
  l_input_value_text.OnPressPtr      = 0;

  l_input_value_min.OwnerScreen     = &ValueInputScreen;
  l_input_value_min.Order           = 25;
  l_input_value_min.Left            = 250;
  l_input_value_min.Top             = 94;
  l_input_value_min.Width           = 98;
  l_input_value_min.Height          = 20;
  l_input_value_min.Visible         = 1;
  l_input_value_min.Active          = 1;
  l_input_value_min.Caption         = l_input_value_min_Caption;
  l_input_value_min.FontName        = Arial_Narrow13x20_Bold;
  l_input_value_min.Font_Color      = 0xFFFF;
  l_input_value_min.VerticalText    = 0;
  l_input_value_min.OnUpPtr         = 0;
  l_input_value_min.OnDownPtr       = 0;
  l_input_value_min.OnClickPtr      = 0;
  l_input_value_min.OnPressPtr      = 0;

  l_input_value_max.OwnerScreen     = &ValueInputScreen;
  l_input_value_max.Order           = 26;
  l_input_value_max.Left            = 250;
  l_input_value_max.Top             = 114;
  l_input_value_max.Width           = 101;
  l_input_value_max.Height          = 20;
  l_input_value_max.Visible         = 1;
  l_input_value_max.Active          = 1;
  l_input_value_max.Caption         = l_input_value_max_Caption;
  l_input_value_max.FontName        = Arial_Narrow13x20_Bold;
  l_input_value_max.Font_Color      = 0xFFFF;
  l_input_value_max.VerticalText    = 0;
  l_input_value_max.OnUpPtr         = 0;
  l_input_value_max.OnDownPtr       = 0;
  l_input_value_max.OnClickPtr      = 0;
  l_input_value_max.OnPressPtr      = 0;

  l_ValueInDisplay.OwnerScreen     = &ValueInputScreen;
  l_ValueInDisplay.Order           = 27;
  l_ValueInDisplay.Left            = 15;
  l_ValueInDisplay.Top             = 33;
  l_ValueInDisplay.Width           = 14;
  l_ValueInDisplay.Height          = 21;
  l_ValueInDisplay.Visible         = 1;
  l_ValueInDisplay.Active          = 1;
  l_ValueInDisplay.Caption         = l_ValueInDisplay_Caption;
  l_ValueInDisplay.FontName        = Tahoma16x19_Regular;
  l_ValueInDisplay.Font_Color      = 0x0000;
  l_ValueInDisplay.VerticalText    = 0;
  l_ValueInDisplay.OnUpPtr         = 0;
  l_ValueInDisplay.OnDownPtr       = 0;
  l_ValueInDisplay.OnClickPtr      = 0;
  l_ValueInDisplay.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetRoundButton(index)         CurrentScreen->Buttons_Round[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetImage(index)               CurrentScreen->Images[index]
#define GetCircle(index)              CurrentScreen->Circles[index]
#define GetBox(index)                 CurrentScreen->Boxes[index]
#define GetBox_Round(index)           CurrentScreen->Boxes_Round[index]
#define GetLine(index)                CurrentScreen->Lines[index]

void DrawButton(TButton *Abutton) {
unsigned int ALeft, ATop;
  if (Abutton->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    if (Abutton->VerticalText != 0)
      TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      ALeft = Abutton->Left + 4;
    else if (Abutton->TextAlign == _taCenter)
      ALeft = Abutton->Left + (Abutton->Width - caption_length) / 2;
    else if (Abutton->TextAlign == _taRight)
      ALeft = Abutton->Left + Abutton->Width - caption_length - 4;

    if (Abutton->TextAlignVertical == _tavTop)
      ATop = Abutton->Top + 4;
    else if (Abutton->TextAlignVertical == _tavMiddle)
      ATop = Abutton->Top + ((Abutton->Height - caption_height) / 2);
    else if (Abutton->TextAlignVertical == _tavBottom)
      ATop = Abutton->Top + (Abutton->Height - caption_height - 4);

    TFT_Write_Text(Abutton->Caption, ALeft, ATop);
  }
}

void DrawRoundButton(TButton_Round *Around_button) {
unsigned int ALeft, ATop;
  if (Around_button->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Around_button->Transparent, Around_button->Press_Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                    Around_button->Gradient_End_Color, Around_button->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Around_button->Transparent, Around_button->Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                    Around_button->Gradient_Start_Color, Around_button->Gradient_End_Color);
    }
    TFT_Set_Pen(Around_button->Pen_Color, Around_button->Pen_Width);
    TFT_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
      Around_button->Left + Around_button->Width - 2,
      Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius);
    if (Around_button->VerticalText != 0)
      TFT_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
    if (Around_button->TextAlign == _taLeft)
      ALeft = Around_button->Left + 4;
    else if (Around_button->TextAlign == _taCenter)
      ALeft = Around_button->Left + (Around_button->Width - caption_length) / 2;
    else if (Around_button->TextAlign == _taRight)
      ALeft = Around_button->Left + Around_button->Width - caption_length - 4;

    if (Around_button->TextAlignVertical == _tavTop)
      ATop = Around_button->Top + 3;
    else if (Around_button->TextAlignVertical == _tavMiddle)
      ATop = Around_button->Top + (Around_button->Height - caption_height) / 2;
    else if (Around_button->TextAlignVertical == _tavBottom)
      ATop  = Around_button->Top + Around_button->Height - caption_height - 4;

    TFT_Write_Text(Around_button->Caption, ALeft, ATop);
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible != 0) {
    if (ALabel->VerticalText != 0)
      TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawImage(TImage *AImage) {
  if (AImage->Visible != 0) {
    if (AImage->Picture_Type == 0)
      TFT_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
    if (AImage->Picture_Type == 1)
      TFT_Image_Jpeg(AImage->Left, AImage->Top, AImage->Picture_Name);
  }
}

void DrawCircle(TCircle *ACircle) {
  if (ACircle->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ACircle->Transparent, ACircle->Press_Color, ACircle->Gradient, ACircle->Gradient_Orientation,
                    ACircle->Gradient_End_Color, ACircle->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ACircle->Transparent, ACircle->Color, ACircle->Gradient, ACircle->Gradient_Orientation,
                    ACircle->Gradient_Start_Color, ACircle->Gradient_End_Color);
    }
    TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
    TFT_Circle(ACircle->Left + ACircle->Radius,
               ACircle->Top + ACircle->Radius,
               ACircle->Radius);
  }
}

void DrawBox(TBox *ABox) {
  if (ABox->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawRoundBox(TBox_Round *Around_box) {
  if (Around_box->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Around_box->Transparent, Around_box->Press_Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                    Around_box->Gradient_End_Color, Around_box->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Around_box->Transparent, Around_box->Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                    Around_box->Gradient_Start_Color, Around_box->Gradient_End_Color);
    }
    TFT_Set_Pen(Around_box->Pen_Color, Around_box->Pen_Width);
    TFT_Rectangle_Round_Edges(Around_box->Left + 1, Around_box->Top + 1,
      Around_box->Left + Around_box->Width - 2,
      Around_box->Top + Around_box->Height - 2, Around_box->Corner_Radius);
  }
}

void DrawLine(TLine *Aline) {
  if (Aline->Visible != 0) {
    TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
    TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short round_button_idx;
  TButton_Round *local_round_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short image_idx;
  TImage *local_image;
  unsigned short circle_idx;
  TCircle *local_circle;
  unsigned short box_idx;
  TBox *local_box;
  unsigned short round_box_idx;
  TBox_Round *local_round_box;
  unsigned short line_idx;
  TLine *local_line;
  char save_bled;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  round_button_idx = 0;
  label_idx = 0;
  image_idx = 0;
  circle_idx = 0;
  box_idx = 0;
  round_box_idx = 0;
  line_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    TFT_BLED           = 0;
    TFT_Set_Active(Set_Index, Write_Command, Write_Data);
    TFT_Init_SSD1963(CurrentScreen->Width, CurrentScreen->Height);
    STMPE610_SetSize(CurrentScreen->Width, CurrentScreen->Height);
    TFT_Fill_Screen(CurrentScreen->Color);
    TFT_Set_DBC_SSD1963(255);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
      local_round_button = GetRoundButton(round_button_idx);
      if (order == local_round_button->Order) {
        round_button_idx++;
        order++;
        DrawRoundButton(local_round_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (circle_idx < CurrentScreen->CirclesCount) {
      local_circle = GetCircle(circle_idx);
      if (order == local_circle->Order) {
        circle_idx++;
        order++;
        DrawCircle(local_circle);
      }
    }

    if (box_idx < CurrentScreen->BoxesCount) {
      local_box = GetBox(box_idx);
      if (order == local_box->Order) {
        box_idx++;
        order++;
        DrawBox(local_box);
      }
    }

    if (round_box_idx < CurrentScreen->Boxes_RoundCount) {
      local_round_box = GetBox_Round(round_box_idx);
      if (order == local_round_box->Order) {
        round_box_idx++;
        order++;
        DrawRoundBox(local_round_box);
      }
    }

    if (line_idx < CurrentScreen->LinesCount) {
      local_line = GetLine(line_idx);
      if (order == local_line->Order) {
        line_idx++;
        order++;
        DrawLine(local_line);
      }
    }

    if (image_idx < CurrentScreen->ImagesCount) {
      local_image = GetImage(image_idx);
      if (order == local_image->Order) {
        image_idx++;
        order++;
        DrawImage(local_image);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  button_order        = -1;
  round_button_order  = -1;
  label_order         = -1;
  image_order         = -1;
  circle_order        = -1;
  box_order           = -1;
  box_round_order     = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton(_object_count);
    if (local_button->Active != 0) {
      if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height) == 1) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  Buttons with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
    local_round_button = GetRoundButton(_object_count);
    if (local_round_button->Active != 0) {
      if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
                         local_round_button->Width, local_round_button->Height) == 1) {
        round_button_order = local_round_button->Order;
        exec_round_button = local_round_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active != 0) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Images
  for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
    local_image = GetImage(_object_count);
    if (local_image->Active != 0) {
      if (IsInsideObject(X, Y, local_image->Left, local_image->Top,
                         local_image->Width, local_image->Height) == 1) {
        image_order = local_image->Order;
        exec_image = local_image;
      }
    }
  }

  //  Circles
  for ( _object_count = 0 ; _object_count < CurrentScreen->CirclesCount ; _object_count++ ) {
    local_circle = GetCircle(_object_count);
    if (local_circle->Active != 0) {
      if (IsInsideObject(X, Y, local_circle->Left, local_circle->Top,
                        (local_circle->Radius * 2), (local_circle->Radius * 2)) == 1) {
        circle_order = local_circle->Order;
        exec_circle = local_circle;
      }
    }
  }

  //  Boxes
  for ( _object_count = 0 ; _object_count < CurrentScreen->BoxesCount ; _object_count++ ) {
    local_box = GetBox(_object_count);
    if (local_box->Active != 0) {
      if (IsInsideObject(X, Y, local_box->Left, local_box->Top,
                         local_box->Width, local_box->Height) == 1) {
        box_order = local_box->Order;
        exec_box = local_box;
      }
    }
  }

  //  Boxes with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Boxes_RoundCount ; _object_count++ ) {
    local_round_box = GetBox_Round(_object_count);
    if (local_round_box->Active != 0) {
      if (IsInsideObject(X, Y, local_round_box->Left, local_round_box->Top,
                         local_round_box->Width, local_round_box->Height) == 1) {
        box_round_order = local_round_box->Order;
        exec_round_box = local_round_box;
      }
    }
  }

  _object_count = -1;
  if (button_order >  _object_count )
    _object_count = button_order;
  if (round_button_order >  _object_count )
    _object_count = round_button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (image_order >  _object_count )
    _object_count = image_order;
  if (circle_order >  _object_count )
    _object_count = circle_order;
  if (box_order >  _object_count )
    _object_count = box_order;
  if (box_round_order >  _object_count )
    _object_count = box_round_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_image          = 0;
  exec_circle         = 0;
  exec_box            = 0;
  exec_round_box      = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnPressPtr != 0) {
          exec_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == round_button_order) {
      if (exec_round_button->Active != 0) {
        if (exec_round_button->OnPressPtr != 0) {
          exec_round_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        if (exec_image->OnPressPtr != 0) {
          exec_image->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == circle_order) {
      if (exec_circle->Active != 0) {
        if (exec_circle->OnPressPtr != 0) {
          exec_circle->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active != 0) {
        if (exec_box->OnPressPtr != 0) {
          exec_box->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_round_order) {
      if (exec_round_box->Active != 0) {
        if (exec_round_box->OnPressPtr != 0) {
          exec_round_box->OnPressPtr();
          return;
        }
      }
    }

  }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Button
    case 0: {
      if (PressedObject != 0) {
        exec_button = (TButton*)PressedObject;
        if ((exec_button->PressColEnabled != 0) && (exec_button->OwnerScreen == CurrentScreen)) {
          DrawButton(exec_button);
        }
        break;
      }
      break;
    }
    // Round Button
    case 1: {
      if (PressedObject != 0) {
        exec_round_button = (TButton_Round*)PressedObject;
        if ((exec_round_button->PressColEnabled != 0) && (exec_round_button->OwnerScreen == CurrentScreen)) {
          DrawRoundButton(exec_round_button);
        }
        break;
      }
      break;
    }
    // Circle
    case 4: {
      if (PressedObject != 0) {
        exec_circle = (TCircle*)PressedObject;
        if ((exec_circle->PressColEnabled != 0) && (exec_circle->OwnerScreen == CurrentScreen)) {
          DrawCircle(exec_circle);
        }
        break;
      }
      break;
    }
    // Box
    case 6: {
      if (PressedObject != 0) {
        exec_box = (TBox*)PressedObject;
        if ((exec_box->PressColEnabled != 0) && (exec_box->OwnerScreen == CurrentScreen)) {
          DrawBox(exec_box);
        }
        break;
      }
      break;
    }
    // Round Box
    case 7: {
      if (PressedObject != 0) {
        exec_round_box = (TBox_Round*)PressedObject;
        if ((exec_round_box->PressColEnabled != 0) && (exec_round_box->OwnerScreen == CurrentScreen)) {
          DrawRoundBox(exec_round_box);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_image          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnUpPtr != 0)
          exec_button->OnUpPtr();
        if (PressedObject == (void *)exec_button)
          if (exec_button->OnClickPtr != 0)
            exec_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Buttons with Round Edges
    if (_object_count == round_button_order) {
      if (exec_round_button->Active != 0) {
        if (exec_round_button->OnUpPtr != 0)
          exec_round_button->OnUpPtr();
        if (PressedObject == (void *)exec_round_button)
          if (exec_round_button->OnClickPtr != 0)
            exec_round_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Images
    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        if (exec_image->OnUpPtr != 0)
          exec_image->OnUpPtr();
        if (PressedObject == (void *)exec_image)
          if (exec_image->OnClickPtr != 0)
            exec_image->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Circles
    if (_object_count == circle_order) {
      if (exec_circle->Active != 0) {
        if (exec_circle->OnUpPtr != 0)
          exec_circle->OnUpPtr();
        if (PressedObject == (void *)exec_circle)
          if (exec_circle->OnClickPtr != 0)
            exec_circle->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes
    if (_object_count == box_order) {
      if (exec_box->Active != 0) {
        if (exec_box->OnUpPtr != 0)
          exec_box->OnUpPtr();
        if (PressedObject == (void *)exec_box)
          if (exec_box->OnClickPtr != 0)
            exec_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes with Round Edges
    if (_object_count == box_round_order) {
      if (exec_round_box->Active != 0) {
        if (exec_round_box->OnUpPtr != 0)
          exec_round_box->OnUpPtr();
        if (PressedObject == (void *)exec_round_box)
          if (exec_round_box->OnClickPtr != 0)
            exec_round_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_image          = 0;
  exec_circle         = 0;
  exec_box            = 0;
  exec_round_box      = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->PressColEnabled != 0) {
          object_pressed = 1;
          DrawButton(exec_button);
        }
        PressedObject = (void *)exec_button;
        PressedObjectType = 0;
        if (exec_button->OnDownPtr != 0) {
          exec_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == round_button_order) {
      if (exec_round_button->Active != 0) {
        if (exec_round_button->PressColEnabled != 0) {
          object_pressed = 1;
          DrawRoundButton(exec_round_button);
        }
        PressedObject = (void *)exec_round_button;
        PressedObjectType = 1;
        if (exec_round_button->OnDownPtr != 0) {
          exec_round_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        PressedObject = (void *)exec_image;
        PressedObjectType = 3;
        if (exec_image->OnDownPtr != 0) {
          exec_image->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == circle_order) {
      if (exec_circle->Active != 0) {
        if (exec_circle->PressColEnabled != 0) {
          object_pressed = 1;
          DrawCircle(exec_circle);
        }
        PressedObject = (void *)exec_circle;
        PressedObjectType = 4;
        if (exec_circle->OnDownPtr != 0) {
          exec_circle->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active != 0) {
        if (exec_box->PressColEnabled != 0) {
          object_pressed = 1;
          DrawBox(exec_box);
        }
        PressedObject = (void *)exec_box;
        PressedObjectType = 6;
        if (exec_box->OnDownPtr != 0) {
          exec_box->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_round_order) {
      if (exec_round_box->Active != 0) {
        if (exec_round_box->PressColEnabled != 0) {
          object_pressed = 1;
          DrawRoundBox(exec_round_box);
        }
        PressedObject = (void *)exec_round_box;
        PressedObjectType = 7;
        if (exec_round_box->OnDownPtr != 0) {
          exec_round_box->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (STMPE610_PressDetect()) {
    if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
char _cnt;
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_6);
  
  // LED outputs (Red, Green, Blue)
  GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_15);
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_3 | _GPIO_PINMASK_4);

  for (_cnt = 0; _cnt < 20; _cnt++) {
    GPIOB_ODR.B6 = 0;
    Delay_ms(1);
    GPIOB_ODR.B6 = 1;
    Delay_ms(1);
  }

  I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
  TFT_Set_Default_Mode();
  GPIO_Digital_Output(&GPIOG_BASE, 0x00FF);
  GPIO_Digital_Output(&GPIOE_BASE, 0xFF00);
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
  GPIOB_ODR.B4 = 0;
  TFT_Set_Default_Mode();
  TFT_Set_MM_Plus();
  STMPE610_SetDefaultMode();
  
  // T1mer2 --> used for the soft timers
  InitTimer2();
  resetTimers();
}

char STMPE610_Config()  {
  STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
  if (STMPE610_IsOperational() != 0){
    return STMPE610_IO_NOT_OPERATIONAL;
  }

  STMPE610_Reset();
  STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
  STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
  STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);   // IN1 to "0" -> I2C communication
  STMPE610_SetSize(480,272);
  STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
  STMPE610_EnableInterrupt(STMPE610_IE_TOUCH_DET | STMPE610_IE_FIFO_TH | STMPE610_IE_FIFO_0FLOW, STMPE610_ENABLE);
  STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_HIGH | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
  STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_44 | STMPE610_ADC_CTRL1_ADC_10BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
  Delay_10ms(); Delay_10ms();
  STMPE610_SetADCClock(STMPE610_ADC_CTRL2_6500_kHZ);
  STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
  STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_8S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_500uS, STMPE610_TSC_CFG_TOUCH_SETTLING_500uS);
  STMPE610_SetFIFOThreshold(1);
  STMPE610_ResetFIFO();
  STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
  STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
  STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
  STMPE610_SetTouchPressureThreshold(70);
  STMPE610_ClearInterrupts();
  STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
  return STMPE610_OK;
}


void Start_TP() {
TTPConstants TPConstsStruct;
  Init_MCU();

  InitializeTouchPanel();
  if (STMPE610_Config() == STMPE610_OK) {
  } else {
    while(1);
  }


  // You can get calibration constants using touch panel calibration example
  TPConstsStruct.X_Min = 105;
  TPConstsStruct.X_Max = 3925;
  TPConstsStruct.Y_Min = 250;
  TPConstsStruct.Y_Max = 3820;
  TPConstsStruct.Rotate = 0;
  STMPE610_SetCalibrationConsts(&TPConstsStruct);

  InitializeObjects();
  display_width = home.Width;
  display_height = home.Height;
  DrawScreen(&home);
  screenState = SCRN_HOME;
}
