#include "mmp_leddemo_objects.h"
#include "mmp_leddemo_resources.h"

//--------------------- User code ---------------------//
#include "types.h"
#include "mmp_leddemo_helpers.h"
TLabel *SelectedField;
uint8_t selectedVar;
//extern TLabel *SelectedField;

uint8_t CheckValueUnsigned(uint8_t Value, uint8_t MinValue, uint8_t MaxValue)
{
   if (Value < MinValue) return MinValue;
   if (Value > MaxValue) return MaxValue;
   return Value;
}

sint8_t CheckValueSigned(sint8_t Value, sint8_t MinValue, sint8_t MaxValue)
{
   if (Value < MinValue) return MinValue;
   if (Value > MaxValue) return MaxValue;
   return Value;
}

sint8_t tmp;

//----------------- End of User code ------------------//

// Event Handlers


// BLUE led
void BlueOn() {
    LED_B = 1;
    blinkLED_B = 0;
    hlpBlueLedOn();
}

void BlueOff() {
   LED_B = 0;
   blinkLED_B = 0;
   hlpBlueLedOff();
   hlpCAN_RxIndicatorOff();
}

void BlueBlink() {
   if (blinkLED_B == 0)
   {
     blinkLED_B = 1;
     T100ms[_T100ms_LED_G] = 0;
   }
}

// GREEN led
void GreenOn() {
    LED_G = 1;
    blinkLED_G = 0;
    hlpGreenLedOn();
}

void GreenOff() {
    LED_G = 0;
    blinkLED_G = 0;
    hlpGreenLedOff();
}

void GreenBlink() {
    blinkLED_G = 1;
}

// RED led
void RedOn() {
     LED_R = 1;
     blinkLED_R = 0;
     hlpRedLedOn();
}

void RedOff() {
     LED_R = 0;
     blinkLED_R = 0;
     hlpRedLedOff();
}

void RedBlink() {
    blinkLED_R = 1;
}

// =====================
// === Screens =========
// =====================


void InfoScreen() {
      screenState = SCRN_HELP;
      DrawScreen(&help_screen);
}

void Back2Home() {

      // Force an update of any (new) CAN data in the display when the HOME screen is displayed
      UpdateCanData = 1;
      
      screenState = SCRN_HOME;
      DrawScreen(&home);
}

void ValueInputScreen_Accept() {
    hlpAcceptValueInInputField(SelectedField->Caption);
    switch (selectedVar)
    {
      case FIELD_BLINKINGSPEED_GREEN:
             BlinkingSpeedGreen.speed = CheckValueSigned((sint8_t)atol(SelectedField->Caption), (sint8_t)BlinkingSpeedGreen.limit_min, (sint8_t)BlinkingSpeedGreen.limit_max) ;

             // Update field in HOME screen with (new) value.
             updateBoxblinkspeedGreen = 1;
      break;
      
      case FIELD_BLINKINGSPEED_BLUE:
             BlinkingSpeedBlue.speed = CheckValueSigned((sint8_t)atol(SelectedField->Caption), (sint8_t)BlinkingSpeedBlue.limit_min, (sint8_t)BlinkingSpeedBlue.limit_max) ;
             
             // Update field in HOME screen with (new) value.
             updateBoxblinkspeedBlue = 1;
      break;
      
      default:
             BlinkingSpeedRed.speed = CheckValueSigned((sint8_t)atol(SelectedField->Caption), (sint8_t)BlinkingSpeedRed.limit_min, (sint8_t)BlinkingSpeedRed.limit_max) ;
             
             // Update field in HOME screen with (new) value.
             updateBoxblinkspeedRed = 1;
    }
    T100ms[_T100ms_CAN] = 0; // reset CAN write timer to force a CAN message being transmitted
    Back2Home();
}

void ValueInputScreen_BackSpace() {
    hlpDeleteLastCharacterInInputField(&l_ValueInDisplay, Box_display.Color) ;
}
void ValueInputScreen_Clear() {
    hlpClearValueInInputField(&l_ValueInDisplay, Box_display.Color) ;

}
void ValueInputScreen_Close() {
    Back2Home();
}
void ValueInputScreen_1() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "1", 25, Box_display.Color) ;
}
void ValueInputScreen_2() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "2", 25, Box_display.Color) ;
}
void ValueInputScreen_3() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "3", 25, Box_display.Color) ;
}
void ValueInputScreen_4() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "4", 25, Box_display.Color) ;
}
void ValueInputScreen_5() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "5", 25, Box_display.Color) ;
}
void ValueInputScreen_6() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "6", 25, Box_display.Color) ;
}
void ValueInputScreen_7() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "7", 25, Box_display.Color) ;
}
void ValueInputScreen_8() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "8", 25, Box_display.Color) ;
}
void ValueInputScreen_9() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "9", 25, Box_display.Color) ;
}
void ValueInputScreen_0() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, "0", 25, Box_display.Color) ;
}
void ValueInputScreen_dot() {
    hlpAddCharacterInInputField(&l_ValueInDisplay, ".", 25, &l_ValueInDisplay) ;
}
void ValueInputScreen_plusminus() {
    hlpToggleMinusCharacterInInputField(&l_ValueInDisplay, &l_ValueInDisplay);
}
void SetBlinkingSpeedRed() {

    uint8_t tmpBuffer[25];

    screenState = SCRN_INPUT_VALUE;
    selectedVar = FIELD_BLINKINGSPEED_RED;
    SelectedField = &l_blinkspeed_red;
    strcpy(l_ValueInDisplay.Caption,SelectedField->Caption);
    strcat(l_ValueInDisplay.Caption, "_");
    
    strcpy(l_input_value_text.Caption, "red led blink speed");
    
    strcpy(l_input_value_min.Caption, "minimum value: ");
    LongLongSignedToStr(BlinkingSpeedRed.limit_min, tmpBuffer);
    strcat(l_input_value_min.Caption, tmpBuffer);
    
    strcpy(l_input_value_max.Caption, "maximum value: ");
    LongLongSignedToStr(BlinkingSpeedRed.limit_max, tmpBuffer);
    strcat(l_input_value_max.Caption, tmpBuffer);
    
    DrawScreen(&ValueInputScreen);
}
void SetBlinkingSpeedGreen() {
    
    uint8_t tmpBuffer[25];

    screenState = SCRN_INPUT_VALUE;
    selectedVar = FIELD_BLINKINGSPEED_GREEN;
    SelectedField = &l_blinkspeed_green;
    strcpy(l_ValueInDisplay.Caption,SelectedField->Caption);
    strcat(l_ValueInDisplay.Caption, "_");

    strcpy(l_input_value_text.Caption, "green led blink speed");

    strcpy(l_input_value_min.Caption, "minimum value: ");
    LongLongSignedToStr(BlinkingSpeedGreen.limit_min, tmpBuffer);
    strcat(l_input_value_min.Caption, tmpBuffer);

    strcpy(l_input_value_max.Caption, "maximum value: ");
    LongLongSignedToStr(BlinkingSpeedGreen.limit_max, tmpBuffer);
    strcat(l_input_value_max.Caption, tmpBuffer);
    
    DrawScreen(&ValueInputScreen);
}
void SetBlinkingSpeedBlue() {
    
    uint8_t tmpBuffer[25];

    screenState = SCRN_INPUT_VALUE;
    selectedVar = FIELD_BLINKINGSPEED_BLUE;
    SelectedField = &l_blinkspeed_blue;
    strcpy(l_ValueInDisplay.Caption,SelectedField->Caption);
    strcat(l_ValueInDisplay.Caption, "_");
    
     strcpy(l_input_value_text.Caption, "blue led blink speed");

    strcpy(l_input_value_min.Caption, "minimum value: ");
    LongLongSignedToStr(BlinkingSpeedBlue.limit_min, tmpBuffer);
    strcat(l_input_value_min.Caption, tmpBuffer);

    strcpy(l_input_value_max.Caption, "maximum value: ");
    LongLongSignedToStr(BlinkingSpeedBlue.limit_max, tmpBuffer);
    strcat(l_input_value_max.Caption, tmpBuffer);
    
    DrawScreen(&ValueInputScreen);
}