/*
 * Project name:
     mmp_leddemo.mcpar
 * Generated by:
     Visual TFT
 * Date of creation
     5-1-2018
 * Test configuration:
     MCU:             STM32F746ZG
     Dev.Board:       Mikromedia_Plus_for_STM32F746ZG_ARM_JE
     Oscillator:      216000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
 */

#include "mmp_leddemo_objects.h"
#include "types.h"
#include "circularbuffer.h"
#include "CAN.h"
#include "mmp_leddemo_helpers.h"
#include "mmp_screenhandler.h"

// Lets rock...
void main() {

  // local CAN message holder
  CANmsg_t CANmsg;

  // No blinking of leds
  blinkLED_R = 0;
  blinkLED_G = 0;
  blinkLED_B = 0;
  
  // CAN display leds off
  ledstatusCANTX = 0;
  ledstatusCANRX = 0;
  
  // Default blink speed for the RGB (display) leds
  BlinkingSpeedRed.defaultvalue    = 5;
  BlinkingSpeedGreen.defaultvalue  = 5;
  BlinkingSpeedBlue.defaultvalue   = 5;
  
  BlinkingSpeedRed.speed = BlinkingSpeedRed.defaultvalue;
  BlinkingSpeedRed.limit_min = 1;
  BlinkingSpeedRed.limit_max = 10;
  
  BlinkingSpeedGreen.speed = BlinkingSpeedGreen.defaultvalue;
  BlinkingSpeedGreen.limit_min = 1;
  BlinkingSpeedGreen.limit_max = 10;
  
  BlinkingSpeedBlue.speed = BlinkingSpeedBlue.defaultvalue;
  BlinkingSpeedBlue.limit_min = 1;
  BlinkingSpeedBlue.limit_max = 10;
  
  // Update field boxes for blink speed.
  updateBoxblinkspeedRed   = 1;
  updateBoxblinkspeedGreen = 1;
  updateBoxblinkspeedBlue  = 1;
  
  // Create the CAN buffer;
  ringBufS_init(&ringBufferCAN);
  ringBufS_flush(&ringBufferCAN, 1);
  
  // Update CAN data.
  UpdateCanData = 1;
  
  // Send CAN message every second.
  T100ms[_T100ms_CAN] = 10;

  // Setup the CAN bus
  Init_CAN();

  // Setup the designed display
  Start_TP();
  
  // All interrupts on.
  EnableInterrupts();

  // endless loop...
  while (1) {

    // Handle display
    Check_TP();
    
    // Handle the screen specific actions
    ScreenHandler();
    
    // Write a CAN message every second
    if (T100ms[_T100ms_CAN] == 0)
    {
       T100ms[_T100ms_CAN] = CAN_RETRANSMIT_TIME;
       WriteCAN_Message();
    }
  }
}
