/*
 * Project name:
     mmp_leddemo.mcpar
 * Generated by:
     Visual TFT
 * Date of creation
     27-12-2017 by Jack Eberson
 * Test configuration:
     MCU:             STM32F746ZG
     Dev.Board:       Mikromedia Plus for STM32F746ZG ARM with shield.
     Oscillator:      216000000 Hz
     SW:              mikroC PRO for ARM V6.0.0 or higher.

    System Clock Configuration
    ===========================
      System Clock source            = PLL (HSE)
      SYSCLK(Hz)                     = 216000000
      HCLK(Hz)                       = 216000000
      AHB Prescaler                  = 1
      APB1 Prescaler                 = 4  --> APB1 clock: 216 / 4 = 54MHz
      APB2 Prescaler                 = 2
      HSE Frequency(Hz)              = 25000000
      PLL_M                          = 25
      PLL_N                          = 432
      PLL_P                          = 2
      PLL_Q                          = 9
      VDD(V)                         = 3.3
      Main regulator output voltage  = Scale1 mode
      Flash Latency(WS)              = 7

      This project was created as a simple learning projct to get familiar with the VTFT tool
      and the Mikromedia plus board. It demonstrates the use of the touch display and the 
      CAN bus and how the VTFT tool generates the code for the Mikro C Pro for ARM compiler V6.0.0.
      
      Each led of the RGB led module can be switched ON/OFF or set to BLINK by means of the
      9 touch buttons. The blinking speed can be altered by sending different CAN messages.
      The CAN bus uses the interrupt for receiving the CAN messages. The massages are stored in a
      circular message buffer. 
      The CAN bus speed can be set in the code to 250Kb/s or 1000Kb/s.
      
      The display shows the received CAN data and two CAN leds in the display are controlled on
      sending or receiving CAN data.
      
      This project can easily be adapted for other Mikromedia board.
      The CAN bus settings are calculated using the 'CANculator' tool.
      The APB1 clock speed in this projct is 54MHz @ 216MHz MCU clock.
      
      important:
      ==========
      This software can be used freely and 'as is'. 
      I (Jack Eberson) cannot be held accountable for any damage caused by this
      software. The use of this software is at your own risk.
      

*/